//---------------------------------------------------------------------------
#pragma hdrstop

#include "ChipFunctions.h"      //     
#include "LogFunctions.h"       //      
#include "Main.h"               //      
#include "FormFunctions.h"      //     
#include "ProgressBar.h"        //   -
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
chip  SelectedChip;     //  
//---------------------------------------------------------------------------
//---       ------------------------
//---------------------------------------------------------------------------
void InitChip(unsigned int ID)
{ //   

  switch(ID&0x3FE0)     //  5      (  ,   )
  { case 0x2080:        //   PIC16F887
                SelectedChip.Name               = "PIC16F887";          //  
                SelectedChip.ImageName          = "PIC16F882.jpg";      //     (  PIC16F882)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F887");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2060:        //   PIC16F886
                SelectedChip.Name               = "PIC16F886";          //  
                SelectedChip.ImageName          = "PIC16F882.jpg";      //     (  PIC16F882)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F886");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2040:        //   PIC16F884
                SelectedChip.Name               = "PIC16F884";          //  
                SelectedChip.ImageName          = "PIC16F882.jpg";      //     (  PIC16F882)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F884");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2020:        //   PIC16F883
                SelectedChip.Name               = "PIC16F883";          //  
                SelectedChip.ImageName          = "PIC16F882.jpg";      //     (  PIC16F882)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F883");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2000:        //   PIC16F882
                SelectedChip.Name               = "PIC16F882";          //  
                SelectedChip.ImageName          = "PIC16F882.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 128;                  //  Data-   (128 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F882");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1900:        //   PIC16LF727
                SelectedChip.Name               = "PIC16LF727";         //  
                SelectedChip.ImageName          = "PIC16F707.jpg";      //     (  PIC16F707)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF727");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1800:        //   PIC16F727
                SelectedChip.Name               = "PIC16F727";          //  
                SelectedChip.ImageName          = "PIC16F707.jpg";      //     (  PIC16F707)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F727");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1940:        //   PIC16LF724
                SelectedChip.Name               = "PIC16LF724";         //  
                SelectedChip.ImageName          = "PIC16F707.jpg";      //     (  PIC16F707)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF724"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1840:        //   PIC16F724
                SelectedChip.Name               = "PIC16F724";          //  
                SelectedChip.ImageName          = "PIC16F707.jpg";      //     (  PIC16F707)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F724");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1920:        //   PIC16LF726
                SelectedChip.Name               = "PIC16LF726";         //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF726"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1820:        //   PIC16F726
                SelectedChip.Name               = "PIC16F726";          //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F726");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1B40:        //   PIC16LF723A
                SelectedChip.Name               = "PIC16LF723A";        //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF723A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1B00:        //   PIC16F723A
                SelectedChip.Name               = "PIC16F723A";         //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F723A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1960:        //   PIC16LF723
                SelectedChip.Name               = "PIC16LF723";         //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF723"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1860:        //   PIC16F723
                SelectedChip.Name               = "PIC16F723";          //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F723");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1B60:        //   PIC16LF722A
                SelectedChip.Name               = "PIC16LF722A";        //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF722A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1B20:        //   PIC16F722A
                SelectedChip.Name               = "PIC16F722A";         //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F722A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1980:        //   PIC16LF722
                SelectedChip.Name               = "PIC16LF722";         //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //     (  PIC16F722)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF722"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1880:        //   PIC16F722
                SelectedChip.Name               = "PIC16F722";          //  
                SelectedChip.ImageName          = "PIC16F722.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //     ( ,     )
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F722");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1C60:        //   PIC16LF721
                SelectedChip.Name               = "PIC16LF721";         //  
                SelectedChip.ImageName          = "PIC16F720.jpg";      //     (  PIC16F720)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2200;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF721");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1C20:        //   PIC16F721
                SelectedChip.Name               = "PIC16F721";          //  
                SelectedChip.ImageName          = "PIC16F720.jpg";      //     (  PIC16F720)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2200;               //     ( ,     )
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F721");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1C40:        //   PIC16LF720
                SelectedChip.Name               = "PIC16LF720";         //  
                SelectedChip.ImageName          = "PIC16F720.jpg";      //     (  PIC16F720)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2200;               //     ( ,     )
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF720"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1C00:        //   PIC16F720
                SelectedChip.Name               = "PIC16F720";          //  
                SelectedChip.ImageName          = "PIC16F720.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2200;               //     ( ,     )
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F720");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1AE0:        //   PIC16LF707
                SelectedChip.Name               = "PIC16LF707";         //  
                SelectedChip.ImageName          = "PIC16F707.jpg";      //     (  PIC16F707)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF707"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1AC0:        //   PIC16F707
                SelectedChip.Name               = "PIC16F707";          //  
                SelectedChip.ImageName          = "PIC16F707.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F707");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1100:        //   PIC16F648A
                SelectedChip.Name               = "PIC16F648A";         //  
                SelectedChip.ImageName          = "PIC16F627A.jpg";     //     (  PIC16F627A)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 16;                   //      (2*0x8)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 4;                    //     int, 
                SelectedChip.TwrProgExt         = 0;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F648A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1060:        //   PIC16F628A
                SelectedChip.Name               = "PIC16F628A";         //  
                SelectedChip.ImageName          = "PIC16F627A.jpg";     //     (  PIC16F627A)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 128;                  //  Data-   (128 x 8)
                SelectedChip.Area3Size          = 16;                   //      (2*0x8)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 4;                    //     int, 
                SelectedChip.TwrProgExt         = 0;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F628A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1040:        //   PIC16F627A
                SelectedChip.Name               = "PIC16F627A";         //  
                SelectedChip.ImageName          = "PIC16F627A.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 128;                  //  Data-   (128 x 8)
                SelectedChip.Area3Size          = 16;                   //      (2*0x8)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 4;                    //     int, 
                SelectedChip.TwrProgExt         = 0;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F627A"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1200:        //   PIC16F785
                SelectedChip.Name               = "PIC16F785";          //  
                SelectedChip.ImageName          = "PIC16F785.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 6;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F785");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word1, 0x2009 - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x3020:        //   PIC16F753
                if(ID == 0x3030)       //  ,    PIC16F753
                {       SelectedChip.Name               = "PIC16F753";          //  
                        SelectedChip.ImageName          = "PIC16F753.jpg";      //    
                        SelectedChip.ID                 = ID;                   //  
                        SelectedChip.ConfigStart        = 0x2000;               //    
                        SelectedChip.DataStart          = 0x2100;               //    
                        SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                        SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                        SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                        SelectedChip.TerProg            = 6;                    //    , 
                        SelectedChip.TerData            = 0;                    //    , 
                        SelectedChip.TwrProgInt         = 0;                    //     int, 
                        SelectedChip.TwrProgExt         = 3;                    //     ext, 
                        SelectedChip.TwrDataInt         = 0;                    //     int, 
                        SelectedChip.TwrDataExt         = 0;                    //     ext, 
                        InitFormInf(SelectedChip.ID);   //      
                        SendMsgToLog(15," PIC16F753");  //   
                        Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word1, 0x2009 - Calibr.Word2";
                        Form1->Label11->Caption = Form1->Label10->Caption;
                }
                else    //    PIC16F753
                {       SendMsgToLog(15," unknown");    //   ,      
                        Form1->Label10->Caption = "Configuration Memory Map: ?";
                        Form1->Label11->Caption = Form1->Label10->Caption;
                        return;                         //        (     )
                }
                break;
    case 0x14A0:        //   PIC16LF1847
                SelectedChip.Name               = "PIC16LF1847";         //  
                SelectedChip.ImageName          = "PIC16F1826.jpg";     //     (  PIC16F1826)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1847"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1480:        //   PIC16F1847
                SelectedChip.Name               = "PIC16F1847";         //  
                SelectedChip.ImageName          = "PIC16F1826.jpg";     //     (  PIC16F1826)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1847"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1BC0:        //   PIC12LF1840
                SelectedChip.Name               = "PIC12LF1840";        //  
                SelectedChip.ImageName          = "PIC12F1501.jpg";     //     (  PIC12F1501)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12LF1840"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1B80:        //   PIC12F1840
                SelectedChip.Name               = "PIC12F1840";         //  
                SelectedChip.ImageName          = "PIC12F1501.jpg";     //     (  PIC12F1501)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F1840"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x28E0:        //   PIC16LF1829
                SelectedChip.Name               = "PIC16LF1829";        //  
                SelectedChip.ImageName          = "PIC16F1828.jpg";     //     (  PIC16F1828)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1829"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x27E0:        //   PIC16F1829
                SelectedChip.Name               = "PIC16F1829";         //  
                SelectedChip.ImageName          = "PIC16F1828.jpg";     //     (  PIC16F1828)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1829"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x28C0:        //   PIC16LF1828
                SelectedChip.Name               = "PIC16LF1828";        //  
                SelectedChip.ImageName          = "PIC16F1828.jpg";     //     (  PIC16F1828)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1828"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x27C0:        //   PIC16F1828
                SelectedChip.Name               = "PIC16F1828";         //  
                SelectedChip.ImageName          = "PIC16F1828.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1828"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x28A0:        //   PIC16LF1827
                SelectedChip.Name               = "PIC16LF1827";        //  
                SelectedChip.ImageName          = "PIC16F1826.jpg";     //     (  PIC16F1826)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1827"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x27A0:        //   PIC16F1827
                SelectedChip.Name               = "PIC16F1827";         //  
                SelectedChip.ImageName          = "PIC16F1826.jpg";     //     (  PIC16F1826)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1827"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2880:        //   PIC16LF1826
                SelectedChip.Name               = "PIC16LF1826";        //  
                SelectedChip.ImageName          = "PIC16F1826.jpg";     //     (  PIC16F1826)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1826"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2780:        //   PIC16F1826
                SelectedChip.Name               = "PIC16F1826";         //  
                SelectedChip.ImageName          = "PIC16F1826.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1826"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2860:        //   PIC16LF1825
                SelectedChip.Name               = "PIC16LF1825";        //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1825"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2760:        //   PIC16F1825
                SelectedChip.Name               = "PIC16F1825";         //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1825"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2840:        //   PIC16LF1824
                SelectedChip.Name               = "PIC16LF1824";         //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1824"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2740:        //   PIC16F1824
                SelectedChip.Name               = "PIC16F1824";         //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1824"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2820:        //   PIC16LF1823
                SelectedChip.Name               = "PIC16LF1823";         //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1823"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2720:        //   PIC16F1823
                SelectedChip.Name               = "PIC16F1823";         //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1823"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2800:        //   PIC12LF1822
                SelectedChip.Name               = "PIC12LF1822";         //  
                SelectedChip.ImageName          = "PIC12F1822.jpg";     //     (  PIC12F1822)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12LF1822"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2700:        //   PIC12F1822
                SelectedChip.Name               = "PIC12F1822";         //  
                SelectedChip.ImageName          = "PIC12F1822.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0xF000;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 5;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 5;                    //     int, 
                SelectedChip.TwrDataExt         = 3;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F1822"); //   
                Form1->Label10->Caption = "0x8000..0x8003 - User ID, 0x8006 - Device ID, 0x8007 - Config.Word1, 0x8008 - Config.Word2, 0x8009 - Calibr.Word1, 0x800A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1240:        //   PIC16F616
                SelectedChip.Name               = "PIC16F616";          //  
                SelectedChip.ImageName          = "PIC16F610.jpg";      //     (  PIC16F610)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 0;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F616");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2260:        //   PIC16F610
                SelectedChip.Name               = "PIC16F610";          //  
                SelectedChip.ImageName          = "PIC16F610.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 0;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F610");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2240:        //   PIC12F609
                SelectedChip.Name               = "PIC12F609";          //  
                SelectedChip.ImageName          = "PIC12F615.jpg";      //     (  PIC12F615)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 0;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F609");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1360:        //   PIC12F617
                SelectedChip.Name               = "PIC12F617";          //  
                SelectedChip.ImageName          = "PIC12F615.jpg";      //     (  PIC12F615)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 224;                  //      (2*0x70)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 0;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F617");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2180:        //   PIC12F615
                SelectedChip.Name               = "PIC12F615";          //  
                SelectedChip.ImageName          = "PIC12F615.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 0;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F615");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2E00:        //   PIC16LF1509
                SelectedChip.Name               = "PIC16LF1509";        //  
                SelectedChip.ImageName          = "PIC16F1507.jpg";     //     (  PIC16F1507)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1509");//   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2D40:        //   PIC16F1509
                SelectedChip.Name               = "PIC16F1509";         //  
                SelectedChip.ImageName          = "PIC16F1507.jpg";     //     (  PIC16F1507)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 16384;                //  flash-   (8k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1509"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2DE0:        //   PIC16LF1508
                SelectedChip.Name               = "PIC16LF1508";         //  
                SelectedChip.ImageName          = "PIC16F1507.jpg";     //     (  PIC16F1507)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1508");//   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2D20:        //   PIC16F1508
                SelectedChip.Name               = "PIC16F1508";         //  
                SelectedChip.ImageName          = "PIC16F1507.jpg";     //     (  PIC16F1507)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1508"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2DC0:        //   PIC16LF1507
                SelectedChip.Name               = "PIC16LF1507";        //  
                SelectedChip.ImageName          = "PIC16F1507.jpg";     //     (  PIC16F1507)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1507");//   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2D00:        //   PIC16F1507
                SelectedChip.Name               = "PIC16F1507";         //  
                SelectedChip.ImageName          = "PIC16F1507.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1507"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2DA0:        //   PIC16LF1503
                SelectedChip.Name               = "PIC16LF1503";        //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //     (  PIC16F1503)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16LF1503");//   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2CE0:        //   PIC16F1503
                SelectedChip.Name               = "PIC16F1503";         //  
                SelectedChip.ImageName          = "PIC16F1503.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8200;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 1024;                 //      (2*0x200)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F1503"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2D80:        //   PIC12LF1501
                SelectedChip.Name               = "PIC12LF1501";        //  
                SelectedChip.ImageName          = "PIC12F1501.jpg";     //     (  PIC12F1501)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12LF1501"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x2CC0:        //   PIC12F1501
                SelectedChip.Name               = "PIC12F1501";         //  
                SelectedChip.ImageName          = "PIC12F1501.jpg";     //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x8000;               //    
                SelectedChip.DataStart          = 0x8100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 512;                  //      (2*0x100)
                SelectedChip.TerProg            = 5;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 5;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F1501"); //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word1, 0x2008 - Config.Word2, 0x2009 - Calibr.Word1, 0x200A - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1500:        //   PIC12F752
                SelectedChip.Name               = "PIC12F752";          //  
                SelectedChip.ImageName          = "PIC12F752.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 0;                    //  Data-   (0 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 0;                    //    , 
                SelectedChip.TwrProgInt         = 0;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 0;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F752");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word1, 0x2009 - Calibr.Word2";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1400:        //   PIC16F690
                SelectedChip.Name               = "PIC16F690";          //  
                SelectedChip.ImageName          = "PIC16F631.jpg";      //     (  PIC16F631)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F690");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1340:        //   PIC16F689
                SelectedChip.Name               = "PIC16F689";          //  
                SelectedChip.ImageName          = "PIC16F631.jpg";      //     (  PIC16F631)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F689");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1180:        //   PIC16F688
                SelectedChip.Name               = "PIC16F688";          //  
                SelectedChip.ImageName          = "PIC16F636.jpg";      //     (  PIC16F636)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F688");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1320:        //   PIC16F687
                SelectedChip.Name               = "PIC16F687";          //  
                SelectedChip.ImageName          = "PIC16F631.jpg";      //     (  PIC16F631)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F687");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x04A0:        //   PIC16F685
                SelectedChip.Name               = "PIC16F685";          //  
                SelectedChip.ImageName          = "PIC16F631.jpg";      //     (  PIC16F631)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 8192;                 //  flash-   (4k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F685");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1080:        //   PIC16F684
                SelectedChip.Name               = "PIC16F684";          //  
                SelectedChip.ImageName          = "PIC16F636.jpg";      //     (  PIC16F636)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F684");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1440:        //   PIC16F677
                SelectedChip.Name               = "PIC16F677";          //  
                SelectedChip.ImageName          = "PIC16F631.jpg";      //     (  PIC16F631)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F677");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x10A0:        //   PIC16F636 / PIC16F639
                SelectedChip.Name               = "PIC16F636 / PIC16F639"; //  
                SelectedChip.ImageName          = "PIC16F636.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F636 / PIC16F639");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x1420:        //   PIC16F631
                SelectedChip.Name               = "PIC16F631";          //  
                SelectedChip.ImageName          = "PIC16F631.jpg";      //     (  PIC12F635)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 128;                  //  Data-   (128 x 8)
                SelectedChip.Area3Size          = 256;                  //      (2*0x80)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F631");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x0460:        //   PIC12F683
                SelectedChip.Name               = "PIC12F683";          //  
                SelectedChip.ImageName          = "PIC12F635.jpg";      //     (  PIC12F635)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 4096;                 //  flash-   (2k x 14)
                SelectedChip.Area2Size          = 256;                  //  Data-   (256 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F683");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x0FA0:        //   PIC12F635
                SelectedChip.Name               = "PIC12F635";          //  
                SelectedChip.ImageName          = "PIC12F635.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-   (1k x 14)
                SelectedChip.Area2Size          = 128;                  //  Data-   (128 x 8)
                SelectedChip.Area3Size          = 128;                  //      (2*0x40)
                SelectedChip.TerProg            = 6;                    //    , 
                SelectedChip.TerData            = 6;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 3;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F635");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word, 0x2008 - Calibr.Word";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x10C0:        //   PIC16F630
                SelectedChip.Name               = "PIC16F630";          //  
                SelectedChip.ImageName          = "PIC16F630.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 64;                   //     
                SelectedChip.TerProg            = 8;                    //    , 
                SelectedChip.TerData            = 8;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 2;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F630");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word; The OSCCAL is located in the last word of the Program Memory";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x10E0:        //   PIC16F676
                SelectedChip.Name               = "PIC16F676";          //  
                SelectedChip.ImageName          = "PIC16F630.jpg";      //     (  PIC16F630)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 64;                   //     
                SelectedChip.TerProg            = 8;                    //    , 
                SelectedChip.TerData            = 8;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 2;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC16F676");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word; The OSCCAL is located in the last word of the Program Memory";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x0F80:        //   PIC12F629
                SelectedChip.Name               = "PIC12F629";          //  
                SelectedChip.ImageName          = "PIC12F629.jpg";      //    
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 64;                   //     
                SelectedChip.TerProg            = 8;                    //    , 
                SelectedChip.TerData            = 8;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 2;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F629");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word; The OSCCAL is located in the last word of the Program Memory";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0x0FC0:        //   PIC12F675
                SelectedChip.Name               = "PIC12F675";          //  
                SelectedChip.ImageName          = "PIC12F629.jpg";      //     (  PIC12F629)
                SelectedChip.ID                 = ID;                   //  
                SelectedChip.ConfigStart        = 0x2000;               //    
                SelectedChip.DataStart          = 0x2100;               //    
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 64;                   //     
                SelectedChip.TerProg            = 8;                    //    , 
                SelectedChip.TerData            = 8;                    //    , 
                SelectedChip.TwrProgInt         = 3;                    //     int, 
                SelectedChip.TwrProgExt         = 2;                    //     ext, 
                SelectedChip.TwrDataInt         = 6;                    //     int, 
                SelectedChip.TwrDataExt         = 0;                    //     ext, 
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," PIC12F675");  //   
                Form1->Label10->Caption = "0x2000..0x2003 - User ID, 0x2006 - Device ID, 0x2007 - Config.Word; The OSCCAL is located in the last word of the Program Memory";
                Form1->Label11->Caption = Form1->Label10->Caption;
                break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                Form1->Label10->Caption = "Configuration Memory Map: ?";
                Form1->Label11->Caption = Form1->Label10->Caption;
                return;                         //        (    )
    default:    SendMsgToLog(15," unknown");    //   ,      
                Form1->Label10->Caption = "Configuration Memory Map: ?";
                Form1->Label11->Caption = Form1->Label10->Caption;
                return;                         //        (     )
  }
  //    
  InitArea(1); InitArea(2); InitArea(3);
  //  ,      (     -)
  PlaceDataToForm(6,3); PlaceDataToForm(7,3);   //       RichEdit6  RichEdit7
}
//---------------------------------------------------------------------------
//---     --------------------------------
//---------------------------------------------------------------------------
void InitArea(unsigned char Number)
{ switch(Number)
  { case 1:  //  3FFF-  1 ()
             for(unsigned int i=0; i<262144; i+=2)      //   
             { SelectedChip.Area1[i]    = 0xFF;         //   = 0xFF ()
               SelectedChip.Area1[i+1]  = 0x3F;         //   = 0x3F ()
             }
             break;
    case 2:  //  FF-  2 ()
             for(unsigned int i=0; i<65536; i++)        //   
             { SelectedChip.Area2[i]=0xFF; }            //   = 0xFF
             break;
    case 3:  //  3FFF-  3 ()
             for(unsigned int i=0; i<1024; i+=2)        //   
             { SelectedChip.Area3[i]    = 0xFF;         //   = 0xFF ()
               SelectedChip.Area3[i+1]  = 0x3F;         //   = 0x3F ()
             }
             //      -    
             switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
             { case 0x1C60:     //   PIC16LF721
               case 0x1C20:     //   PIC16F721
               case 0x1C40:     //   PIC16LF720
               case 0x1C00:     //   PIC16F720
                                SelectedChip.Area3[2*6]         = SelectedChip.ID;      //   
                                SelectedChip.Area3[2*6+1]       = SelectedChip.ID>>8;   //   
                                SelectedChip.Area3[2*7+1]       = 0x3C;                 //      (-)
                                break;
               case 0x3020:     //   PIC16F753
                                if(SelectedChip.ID == 0x3030)       //    PIC16F753
                                {       SelectedChip.Area3[2*6]         = SelectedChip.ID;      //   
                                        SelectedChip.Area3[2*6+1]       = SelectedChip.ID>>8;   //   
                                        //  -  0x3FFF,       
                                        break;
                                }
                                break;
               case 0x2060:     //   PIC16F886
               case 0x2040:     //   PIC16F884
               case 0x2020:     //   PIC16F883
               case 0x2000:     //   PIC16F882
               case 0x1900:     //   PIC16LF727
               case 0x1800:     //   PIC16F727
               case 0x1940:     //   PIC16LF724
               case 0x1840:     //   PIC16F724
               case 0x1920:     //   PIC16LF726
               case 0x1820:     //   PIC16F726
               case 0x1B40:     //   PIC16LF723A
               case 0x1B00:     //   PIC16F723A
               case 0x1960:     //   PIC16LF723
               case 0x1860:     //   PIC16F723
               case 0x1B60:     //   PIC16LF722A
               case 0x1B20:     //   PIC16F722A
               case 0x1980:     //   PIC16LF722
               case 0x1880:     //   PIC16F722
               case 0x1AE0:     //   PIC16LF707
               case 0x1AC0:     //   PIC16F707
               case 0x1060:     //   PIC16F628A
               case 0x1040:     //   PIC16F627A
               case 0x1200:     //   PIC16F785
               case 0x1480:     //   PIC16F1847
               case 0x1BC0:     //   PIC12LF1840
               case 0x1B80:     //   PIC12F1840
               case 0x28E0:     //   PIC16LF1829
               case 0x27E0:     //   PIC16F1829
               case 0x28C0:     //   PIC16LF1828
               case 0x27C0:     //   PIC16F1828
               case 0x28A0:     //   PIC16LF1827
               case 0x27A0:     //   PIC16F1827
               case 0x2880:     //   PIC16LF1826
               case 0x2780:     //   PIC16F1826
               case 0x2860:     //   PIC16LF1825
               case 0x2760:     //   PIC16F1825
               case 0x2840:     //   PIC16LF1824
               case 0x2740:     //   PIC16F1824
               case 0x2820:     //   PIC16LF1823
               case 0x2720:     //   PIC16F1823
               case 0x2800:     //   PIC12LF1822
               case 0x2700:     //   PIC12F1822
               case 0x1240:     //   PIC16F616
               case 0x2260:     //   PIC16F610
               case 0x2240:     //   PIC12F609
               case 0x1360:     //   PIC12F617
               case 0x2180:     //   PIC12F615
               case 0x2E00:     //   PIC16LF1509
               case 0x2D40:     //   PIC16F1509
               case 0x2DE0:     //   PIC16LF1508
               case 0x2D20:     //   PIC16F1508
               case 0x2DC0:     //   PIC16LF1507
               case 0x2D00:     //   PIC16F1507
               case 0x2DA0:     //   PIC16LF1503
               case 0x2CE0:     //   PIC16F1503
               case 0x2D80:     //   PIC12LF1501
               case 0x2CC0:     //   PIC12F1501
               case 0x1500:     //   PIC12F752
               case 0x1400:     //   PIC16F690
               case 0x1340:     //   PIC16F689
               case 0x1180:     //   PIC16F688
               case 0x1320:     //   PIC16F687
               case 0x04A0:     //   PIC16F685
               case 0x1080:     //   PIC16F684
               case 0x1440:     //   PIC16F677
               case 0x10A0:     //   PIC16F636 / PIC16F639
               case 0x1420:     //   PIC16F631
               case 0x0460:     //   PIC12F683
               case 0x0FA0:     //   PIC12F635
                                SelectedChip.Area3[2*6]         = SelectedChip.ID;      //   
                                SelectedChip.Area3[2*6+1]       = SelectedChip.ID>>8;   //   
                                //  -  0x3FFF,       
                                break;
               case 0x10C0:     //   PIC16F630
               case 0x10E0:     //   PIC16F676
               case 0x0F80:     //   PIC12F629
               case 0x0FC0:     //   PIC12F675
                                SelectedChip.Area3[2*6]         = SelectedChip.ID;      //   
                                SelectedChip.Area3[2*6+1]       = SelectedChip.ID>>8;   //   
                                SelectedChip.Area3[2*7+1]       = 0x31;                 //    (-)
                                break;
               case 0:
               default:         break;
             }
             break;
    default: break;
  }
}
//---------------------------------------------------------------------------
//---    BIN-   --------------------------------
//---------------------------------------------------------------------------
void LoadFromBinFileToMemory(AnsiString FilePath, unsigned char Area)
{ TFileStream* fs;              //    
  unsigned char rffch[1];       //     
  unsigned int   Position;      //    

  fs=new TFileStream(FilePath,fmOpenRead);      //    
  switch(Area)
  { case 0:     //  ,   EEPROM
                SendMsgToLog(21,FilePath);                              //    BIN-
                InitArea(1); InitArea(2); InitArea(3);                  //  ,     (   )
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)    //   
                { if(fs->Read(rffch,1))                                 //    
                  { SelectedChip.Area1[i]=rffch[0];                     //    
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                  }
                }
                //  PIC-     ,      
                Position = fs->Seek(2*SelectedChip.ConfigStart,soFromBeginning);        //       (2*0x2000)
                if(Position == 2*SelectedChip.ConfigStart)              //   -   
                { for(unsigned int i=0; i<SelectedChip.Area3Size; i++)  //   
                  { if(fs->Read(rffch,1))                               //    
                    { SelectedChip.Area3[i]=rffch[0];                   //    
                    }
                    //   1024 -    -
                    if(i%1024==0)
                    { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area3Size;
                    }
                  }
                }
                else                    //    -  ,     
                { Application->MessageBox("There is no config in the file", "Warning", MB_OK|MB_ICONWARNING|MB_APPLMODAL);
                }
                //  PIC-     ,      
                Position = fs->Seek(2*SelectedChip.DataStart,soFromBeginning);   //       (2*0x2100)
                if(Position == 2*SelectedChip.DataStart)                //   -   
                { for(unsigned int i=0; i<SelectedChip.Area2Size; i++)  //   
                  { if(fs->Read(rffch,1))                               //    
                    { SelectedChip.Area2[i]=rffch[0];                   //    
                    }
                    //   1024 -    -
                    if(i%1024==0)
                    { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                    }
                  }
                }
                else                    //    -  ,     
                { Application->MessageBox("There is no EEPROM data in the file", "Warning", MB_OK|MB_ICONWARNING|MB_APPLMODAL);
                }
                LBar->Free();                                 //    -
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  //   Page1
                           PlaceDataToForm(1,1);   //   RichEdit1 Program
                           PlaceDataToForm(6,3);   //   RichEdit6 Config
                           PlaceDataToForm(3,2);   //   RichEdit3 EEPROM
                           break;
                  case 1:  //   Page2
                           PlaceDataToForm(2,1);   //   RichEdit2 Program
                           PlaceDataToForm(7,3);   //   RichEdit7 Config
                           PlaceDataToForm(4,2);   //   RichEdit4 EEPROM
                           break;
                  default: break;
                }
                break;
    case 1:     //   
                SendMsgToLog(10,FilePath);                              //    BIN-
                InitArea(1);                                            //  ,     (   )
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)    //   
                { if(fs->Read(rffch,1))                                 //    
                  { SelectedChip.Area1[i]=rffch[0];                     //    
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                  }
                }
                LBar->Free();                                 //    -
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  //   Page1
                           PlaceDataToForm(1,1);   //   RichEdit1 Program
                           break;
                  case 1:  //   Page2
                           PlaceDataToForm(2,1);   //   RichEdit2 Program
                           break;
                  default: break;
                }
                break;
    case 2:     //   
                SendMsgToLog(11,FilePath);                              //    BIN-
                InitArea(2);                                            //  ,     (   )
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)    //   
                { if(fs->Read(rffch,1))                                 //    
                  { SelectedChip.Area2[i]=rffch[0];                     //    
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                  }
                }
                LBar->Free();                                 //    -
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  //   Page1
                           PlaceDataToForm(3,2);   //   RichEdit3 Data
                           break;
                  case 1:  //   Page2
                           PlaceDataToForm(4,2);   //   RichEdit4 Data
                           break;
                  default: break;
                }
                break;
    case 3:     //   
                SendMsgToLog(22,FilePath);                              //    BIN-
                InitArea(3);                                            //  ,     (   )
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                for(unsigned int i=0; i<SelectedChip.Area3Size; i++)    //   
                { if(fs->Read(rffch,1))                                 //    
                  { SelectedChip.Area3[i]=rffch[0];                     //    
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area3Size;
                  }
                }
                LBar->Free();                                 //    -
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  //   Page1
                           PlaceDataToForm(6,3);   //   RichEdit6 Config
                           break;
                  case 1:  //   Page2
                           PlaceDataToForm(7,3);   //   RichEdit7 Config
                           break;
                  default: break;
                }
                break;
    default:    break;
  }
  delete fs;                                    //   
  SendMsgToLog(12,"");                          //  
}
//---------------------------------------------------------------------------
//---    HEX-   --------------------------------
//---------------------------------------------------------------------------
void LoadFromHexFileToMemory(AnsiString FilePath, unsigned char Area)
{ AnsiString TempStr, SubStr;
  unsigned char *InBuf, OutBuf[2];                      //  
  unsigned int n, Reclen, Offset, Rectype, Address,
               LinearBaseAddress, SegmentBaseAddress;

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);        //    -
  LBar->Show();                                           //     

  switch(Area)
  { case 0:     //  ,   
                SendMsgToLog(21,FilePath);              //    HEX-
                InitArea(1); InitArea(2); InitArea(3);  //  ,     (   )
                break;
    case 1:     //  
                SendMsgToLog(10,FilePath);              //    HEX-
                InitArea(1);                            //  ,     (   )
                break;
    case 2:     //  
                SendMsgToLog(11,FilePath);              //    HEX-
                InitArea(2);                            //  ,     (   )
                break;
    case 3:     //  
                SendMsgToLog(22,FilePath);              //    HEX-
                InitArea(3);                            //  ,     (   )
                break;
    default:    break;
  }
  LinearBaseAddress=0;    SegmentBaseAddress=0;         //    

  Form1->Memo1->Clear();                                //  Memo
  Form1->Memo1->Lines->LoadFromFile(FilePath);          //    Memo
  n=Form1->Memo1->Lines->Count;                         //     
  for(unsigned int i=0;i<n;i++)                         //    
  {  TempStr=Form1->Memo1->Lines->Strings[i];           //   
     //       
     SubStr=TempStr.SubString(2,2);                     // - -     
     InBuf=SubStr.c_str();
     HexToBin(InBuf,OutBuf,1);                          //     ()
     Reclen=OutBuf[0];                                  //      
     //     
     SubStr=TempStr.SubString(4,4);                     //     
     InBuf=SubStr.c_str();
     HexToBin(InBuf,OutBuf,2);
     Offset=OutBuf[0]*256+OutBuf[1];
     //  
     SubStr=TempStr.SubString(8,2);                     //      
     InBuf=SubStr.c_str();
     HexToBin(InBuf,OutBuf,1);
     Rectype=OutBuf[0];
     switch(Rectype)
     { case 0:  // Data record
                for(unsigned int j=0;j<Reclen;j++)
                { SubStr=LowerCase(TempStr.SubString(10+2*j,2));
                  Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;//  
                  InBuf=SubStr.c_str();                                 // SubStr -     hex
                  HexToBin(InBuf,OutBuf,1);                             //      
                  switch(Area)
                  { case 0:     //  ,   
                                if(Address<SelectedChip.Area1Size)
                                { SelectedChip.Area1[Address]=OutBuf[0];
                                }
                                else if(Address<(2*SelectedChip.ConfigStart+SelectedChip.Area3Size))
                                { SelectedChip.Area3[Address-2*SelectedChip.ConfigStart]=OutBuf[0];
                                }
                                //       ,         
                                //    ,         2,   
                                else if(Address<2*(SelectedChip.DataStart+SelectedChip.Area2Size))
                                { //     (-      ,         ,     )
                                  if(Address%2==0) SelectedChip.Area2[(Address-2*SelectedChip.DataStart)/2]=OutBuf[0];
                                }
                                break;
                    case 1:     //  
                                if(Address<SelectedChip.Area1Size)
                                { SelectedChip.Area1[Address]=OutBuf[0];
                                }
                                break;
                    case 2:     //  
                                //       ,         
                                //    ,        2
                                if(Address<2*SelectedChip.Area2Size)
                                { //     (-      ,         ,     )
                                  if(Address%2==0) SelectedChip.Area2[Address/2]=OutBuf[0];
                                }
                                break;
                    case 3:     //  
                                if(Address<SelectedChip.Area3Size)
                                { SelectedChip.Area3[Address]=OutBuf[0];
                                }
                                break;
                    default:    break;
                  }
                }
                break;
       case 1:  // End of file record
                i=n;    //   
                SendMsgToLog(12,"");                    //    
                break;
       case 2:  // Extended segment address record
                SubStr=TempStr.SubString(10,4);         // Extended segment address    
                InBuf=SubStr.c_str();
                HexToBin(InBuf,OutBuf,2);
                SegmentBaseAddress=(OutBuf[0]*256+OutBuf[1])*16;
                break;
       case 3:  // Start segment address record (  4-19   
                //  ,       )
                i=n;    //   
                SendMsgToLog(13," (from 8086/80186)");   //  HEX-  8086/80186
                break;
       case 4:  // Extended linear address record (  2    
                //  ,       )
                SubStr=TempStr.SubString(10,4);         // Extended linear address    
                InBuf=SubStr.c_str();
                HexToBin(InBuf,OutBuf,2);
                LinearBaseAddress=(OutBuf[0]*256+OutBuf[1])*65536;
                break;
       case 5:  // Start linear address record
                i=n;    //   
                SendMsgToLog(13," (from 80386)");       //  HEX-  80386
                break;
       default: //        - 
                i=n;    //   
                SendMsgToLog(13," (unknown format)");   //   
                break;
     }
     //   1024 -    -
     if(i%1024==0)
     { LBar->ProgressBar1->Position=100*(i+1)/n;
     }
  }
  Form1->Memo1->Clear();          //  Memo
  LBar->Free();                   //    -
  //            
  switch(Form1->PageControl1->TabIndex)
  { case 0:  //   Page1
             switch(Area)
             { case 0:  //  ,   
                        PlaceDataToForm(1,1);   //   RichEdit1 Program
                        PlaceDataToForm(6,3);   //   RichEdit6 
                        PlaceDataToForm(3,2);   //   RichEdit3 
                        break;
               case 1:  //  
                        PlaceDataToForm(1,1);   //   RichEdit1 Program
                        break;
               case 2:  //  
                        PlaceDataToForm(3,2);   //   RichEdit3 Data
                        break;
               case 3:  //  
                        PlaceDataToForm(6,3);   //   RichEdit1 Program
                        break;
               default: break;
             }
             break;
    case 1:  //   Page2
             switch(Area)
             { case 0:  //  ,   
                        PlaceDataToForm(2,1);   //   RichEdit2 Program
                        PlaceDataToForm(7,3);   //   RichEdit7 
                        PlaceDataToForm(4,2);   //   RichEdit4 
                        break;
               case 1:  //  
                        PlaceDataToForm(2,1);   //   RichEdit2 Program
                        break;
               case 2:  //  
                        PlaceDataToForm(4,2);   //   RichEdit4 Data
                        break;
               case 3:  //  
                        PlaceDataToForm(7,3);   //   RichEdit4 Data
                        break;
               default: break;
             }
             break;
    default: break;
  }
}
//---------------------------------------------------------------------------
//---      BIN- ---------------------------------
//---       EEPROM     ,
//---           
//---     ,      
//---------------------------------------------------------------------------
void SaveFromMemoryToBinFile(AnsiString FilePath, unsigned char Area)
{ TFileStream* fs;              //    
  char Symbol[1];               //   

  switch(Area)
  { case 0:     //  ,   
                SendMsgToLog(23,FilePath);      //      BIN-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Area1
                           GetDataToMemory(6,3);  //    RichEdit6  Area3
                           GetDataToMemory(3,2);  //    RichEdit3  Area2
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Area1
                           GetDataToMemory(7,3);  //    RichEdit7  Area3
                           GetDataToMemory(4,2);  //    RichEdit4  Area2
                           break;
                  default: break;
                }
                //----------------------------------------
                //     
                //----------------------------------------
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                //  
                for(unsigned int i=0; i < 2*SelectedChip.ConfigStart; i++)      //    2*0x2000,      
                {     Symbol[0]=char(SelectedChip.Area1[i]);
                      fs->Write(Symbol,1);                              //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/(2*SelectedChip.ConfigStart);
                      }
                }
                //  
                for(unsigned int i=0; i < 2*(SelectedChip.DataStart-SelectedChip.ConfigStart); i++)     // 2*(0x2100 - 0x2000)
                {     if(i<SelectedChip.Area3Size)      Symbol[0]=char(SelectedChip.Area3[i]);  //     
                      else                              Symbol[0]=0xFF;                         //     
                      fs->Write(Symbol,1);                              //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/0x200;
                      }
                }
                //  
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                {     Symbol[0]=char(SelectedChip.Area2[i]);
                      fs->Write(Symbol,1);                            //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                      }
                }
                delete fs;                                            //   
                break;
    case 1:     //  
                SendMsgToLog(16,FilePath);      //      BIN-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Area1
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Area1
                           break;
                  default: break;
                }
                //----------------------------------------
                //     
                //----------------------------------------
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                //  
                for(unsigned int i=0; i < 2*SelectedChip.ConfigStart; i++)      //    2*0x2000,      
                {     Symbol[0]=char(SelectedChip.Area1[i]);
                      fs->Write(Symbol,1);                              //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/(2*SelectedChip.ConfigStart);
                      }
                }
                delete fs;                                            //   
                break;
    case 2:     //  
                SendMsgToLog(17,FilePath);      //      BIN-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);  //    RichEdit3  Area2
                           break;
                  case 1:  GetDataToMemory(4,2);  //    RichEdit4  Area2
                           break;
                  default: break;
                }
                //----------------------------------------
                //     
                //----------------------------------------
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);  //    
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                //  
                {     Symbol[0]=char(SelectedChip.Area2[i]);
                      fs->Write(Symbol,1);                            //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                      }
                }
                delete fs;                                            //   
                break;
    case 3:     //  
                SendMsgToLog(24,FilePath);      //      BIN-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(6,3);  //    RichEdit6  Area3
                           break;
                  case 1:  GetDataToMemory(7,3);  //    RichEdit7  Area3
                           break;
                  default: break;
                }
                //----------------------------------------
                //     
                //----------------------------------------
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);  //    
                for(unsigned int i=0; i<SelectedChip.Area3Size; i++)
                //  
                {     Symbol[0]=char(SelectedChip.Area3[i]);
                      fs->Write(Symbol,1);                            //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area3Size;
                      }
                }
                delete fs;                                            //   
                break;
    default:    break;
  }
  LBar->Free();                 //    -
  SendMsgToLog(12,"");          //  
}
//---------------------------------------------------------------------------
//---      HEX- ---------------------------------
//---    HEX   EEPROM     
//---      ,    
//---  MPLab  EEPROM      
//---------------------------------------------------------------------------
void SaveFromMemoryToHexFile(AnsiString FilePath, unsigned char Area)
{ TFileStream* fs;                      //    
  unsigned char Value[1], OutBuf[2];    //  
  unsigned char CheckSum[1];            //    

  switch(Area)
  { case 0:     //  ,   
                SendMsgToLog(23,FilePath);              //  ,     HEX-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Area1
                           GetDataToMemory(6,3);  //    RichEdit6  Area3
                           GetDataToMemory(3,2);  //    RichEdit3  Area2
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Area1
                           GetDataToMemory(7,3);  //    RichEdit7  Area3
                           GetDataToMemory(4,2);  //    RichEdit4  Area2
                           break;
                  default: break;
                }
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                //  
                for(unsigned int i=0; i<(SelectedChip.Area1Size); i++)
                { if(i%65536==0)        //   65536 -   ULBA ( 2  32-   Extended Linear Address Record)
                  { fs->Write(":02000004",9);   //     -  (:), RECLEN (0x02 = 2 ), OFFSET (0000), RECTYPE (04)
                    CheckSum[0] = 0x02;         //      RECLEN
                    CheckSum[0]+= 0x0;          //  2  OFFSET
                    CheckSum[0]+= 0x0;
                    CheckSum[0]+= 0x4;
                    Value[0] = i >> 24;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    Value[0] = i >> 16;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    //     
                    CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area1[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                  }
                }
                //  
                for(unsigned int i=0; i<SelectedChip.Area3Size; i++)
                { if((2*SelectedChip.ConfigStart+i)%65536==0)       //   65536 -   ULBA ( 2  32-   Extended Linear Address Record)
                  { fs->Write(":02000004",9);   //     -  (:), RECLEN (0x02 = 2 ), OFFSET (0000), RECTYPE (04)
                    CheckSum[0] = 0x02;         //      RECLEN
                    CheckSum[0]+= 0x0;          //  2  OFFSET
                    CheckSum[0]+= 0x0;
                    CheckSum[0]+= 0x4;
                    Value[0] = (2*SelectedChip.ConfigStart + i) >> 24;      //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    Value[0] = (2*SelectedChip.ConfigStart + i) >> 16;      //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    //     
                    CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  if((2*SelectedChip.ConfigStart + i)%8==0)                 //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=(2*SelectedChip.ConfigStart + i)/256;          //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=(2*SelectedChip.ConfigStart + i);              //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area3[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((2*SelectedChip.ConfigStart+i+1)%8==0)                 //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area3Size;
                  }
                }
                //  
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                { if((2*(SelectedChip.DataStart+i))%65536==0)       //   65536 -   ULBA ( 2  32-   Extended Linear Address Record)
                  { fs->Write(":02000004",9);   //     -  (:), RECLEN (0x02 = 2 ), OFFSET (0000), RECTYPE (04)
                    CheckSum[0] = 0x02;         //      RECLEN
                    CheckSum[0]+= 0x0;          //  2  OFFSET
                    CheckSum[0]+= 0x0;
                    CheckSum[0]+= 0x4;
                    Value[0] = (2*(SelectedChip.DataStart+i)) >> 24;     //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    Value[0] = (2*(SelectedChip.DataStart+i)) >> 16;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    //     
                    CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  if((2*(SelectedChip.DataStart+i))%8==0) //    ,     i  8  0 ( 4    4   )
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=(2*(SelectedChip.DataStart+i))/256;            //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=(2*(SelectedChip.DataStart+i));               //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area2[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  Value[0]=0;                           //      
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((2*(SelectedChip.DataStart+i+1))%8==0)    //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                break;
    case 1:     //  
                SendMsgToLog(16,FilePath);              //    HEX-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Area1
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Area1
                           break;
                  default: break;
                }
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                //  
                for(unsigned int i=0; i<(SelectedChip.Area1Size); i++)
                { if(i%65536==0)        //   65536 -   ULBA ( 2  32-   Extended Linear Address Record)
                  { fs->Write(":02000004",9);           //     -  (:), RECLEN (0x02 = 2 ), OFFSET (0000), RECTYPE (04)
                    CheckSum[0] = 0x02;         //      RECLEN
                    CheckSum[0]+= 0x0;          //  2  OFFSET
                    CheckSum[0]+= 0x0;
                    CheckSum[0]+= 0x4;
                    Value[0] = i >> 24;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    Value[0] = i >> 16;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    //     
                    CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area1[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                break;
    case 2:     //  
                SendMsgToLog(17,FilePath);              //    HEX-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);  //    RichEdit3  Area2
                           break;
                  case 1:  GetDataToMemory(4,2);  //    RichEdit4  Area2
                           break;
                  default: break;
                }
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<(SelectedChip.Area2Size); i++)
                { if((2*i)%8==0)                        //    ,     i  8  0 ( 4       4   )
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=2*i/256;                   //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area2[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  Value[0]=0;                           //      
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((2*(i+1))%8==0)                    //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                break;
    case 3:     //  
                SendMsgToLog(24,FilePath);              //    HEX-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(6,3);  //    RichEdit6  Area3
                           break;
                  case 1:  GetDataToMemory(7,3);  //    RichEdit7  Area3
                           break;
                  default: break;
                }
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<(SelectedChip.Area3Size); i++)
                { if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area3[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area3Size;
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                break;
    default:    break;
  }
  LBar->Free();                 //    -
  SendMsgToLog(12,"");                                  //  
}
//---------------------------------------------------------------------------
