//---------------------------------------------------------------------------
#ifndef ChipFunctionsH
#define ChipFunctionsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
void InitChip(unsigned int);                            //   
void InitArea(unsigned char);                           //     FF-
void LoadFromBinFileToMemory(AnsiString, unsigned char);//    bin-    
void LoadFromHexFileToMemory(AnsiString, unsigned char);//    hex-    
void SaveFromMemoryToBinFile(AnsiString, unsigned char);//        bin-
void SaveFromMemoryToHexFile(AnsiString, unsigned char);//        hex-

//---------------------------------------------------------------------------
struct chip { AnsiString Name, ImageName;
              unsigned short ID;                                        //   (     0x2006)
              unsigned int ConfigStart;                                 //    (  )
              unsigned int DataStart;                                   //    (  )

              unsigned char TerProg;                                    //   
              unsigned char TerData;                                    //   
              unsigned char TwrProgInt;                                 //    internally timed
              unsigned char TwrProgExt;                                 //    externally timed
              unsigned char TwrDataInt;                                 //    internally timed
              unsigned char TwrDataExt;                                 //    externally timed

              unsigned int Area1Size; unsigned char Area1[2*128*1024];  //   (max 128 KWords, 256 KByte)                ()
              unsigned int Area2Size; unsigned char Area2[64*1024];     //   (max 64 KByte)                                ()
              unsigned int Area3Size; unsigned char Area3[2*512];};     //   (512 , 1024 )
//---------------------------------------------------------------------------
//---    ----------------------------------
//---------------------------------------------------------------------------
extern struct chip SelectedChip;
//---------------------------------------------------------------------------
#endif
