//---------------------------------------------------------------------------
#pragma hdrstop
#include "PortFunctions.h"      //      
#include "LogFunctions.h"       //     
#include "Main.h"               //      
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
HANDLE Port;                    //  
OVERLAPPED  ovr_wr, ovr_rd;     //  /
//---------------------------------------------------------------------------
//---       --------------------------------------
//---------------------------------------------------------------------------
bool WriteTo(WRITE_BUFFER wr_buf)
{ DWORD temp;

  WriteFile(Port,wr_buf.Data,wr_buf.Size,&temp,&ovr_wr); //    
  WaitForSingleObject(ovr_wr.hEvent,20000);              //    20         
  if(GetOverlappedResult(Port,&ovr_wr,&temp,true)) return true;  //     -  
  else                                             return false; //   - 
}
//---------------------------------------------------------------------------
//--- Ȩ      -----------------------------------------
//---------------------------------------------------------------------------
READ_BUFFER ReadFrom(int Number)
{ READ_BUFFER rd_buf, temp_buf;
  COMSTAT     port_status;
  DWORD       temp, mask;
  int         Counter;

  Counter=0; rd_buf.Size=0; temp_buf.Size=0;
  while((Counter<1000) && (rd_buf.Size<Number)) //   1000        
  { ClearCommError(Port,&temp,&port_status);    //   port_status
    temp_buf.Size=0;
    temp_buf.Size=port_status.cbInQue;          // -  
    if(temp_buf.Size>0)                         //    
    { ReadFile(Port,temp_buf.Data,temp_buf.Size,&temp,&ovr_rd);  //  -    
      for(int i=0; i<temp_buf.Size; i++)
      { rd_buf.Data[rd_buf.Size+i]=temp_buf.Data[i];    //       
      }
      rd_buf.Size += temp_buf.Size;             //      
    }
    Counter++;
    Sleep(1);
  }
  return rd_buf;
}
//---------------------------------------------------------------------------
//---    COM- ----------------------------------------
//---------------------------------------------------------------------------
void OpenCom(char PortName[100])
{ DCB    dcb;           //  DCB
  WRITE_BUFFER wr_buf;  //        
  READ_BUFFER rd_buf;   //    

  dcb.DCBlength=sizeof(DCB);
  //   .     nt-  
  // "\\.\PortName",      \    2 
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { SendMsgToLog(2,"");         // . COM-  
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { SendMsgToLog(4,"");       //    COM-
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    { dcb.BaudRate=250000;
      dcb.ByteSize=8;
      dcb.Parity=0;
      dcb.StopBits=2;
      dcb.fBinary=true;                         //  
      dcb.fOutxCtsFlow=false;                   //  CTS
      dcb.fOutxDsrFlow=false;                   //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;      // DTR
      dcb.fDsrSensitivity=false;                //  DSR
      dcb.fNull=false;                          //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;      // RTS
      dcb.fAbortOnError=false;                  //  /  
    }
    if(SetCommState(Port,&dcb)==0)
    { SendMsgToLog(5,"");                       //   COM-
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }

    SetupComm(Port,BUFSIZE+100,BUFSIZE+100);            //    
    PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);        //     
    //-----------------------------------------------------------------------------------------------
    //---   ( ,     SPI Mode 1, LSB-first)
    //-----------------------------------------------------------------------------------------------
    wr_buf.Size=3;
    wr_buf.Data[0]=0x0A;     // disable autoload
    wr_buf.Data[1]=0x08;     // disable reports
    wr_buf.Data[2]=0x02;     // select interface SPI
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," 0x0A 0x08 0x02");    //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return;
                         }
    Sleep(1);
    Sleep(Delays);//////////
    //---   PG ---
    wr_buf.Size=1;
    wr_buf.Data[0]=0x1E;        // Set Power Good to enable external DC/DC
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," 0x1E");    //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return;
                         }
    Sleep(1);
    Sleep(Delays);//////////
    //---      ---
    //---   ,      ,        ---
    //---   1 ,        ,     ---
    wr_buf.Size=1;
    wr_buf.Data[0]=0x04;        // Read Error
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," 0x1E");     //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return;
                         }
    rd_buf=ReadFrom(1);                                 // 
    if(!rd_buf.Size) { SendMsgToLog(7," (PINB)");    //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return;
                         }
    //---------------------------------------------------------------
    //---  SPI Mode 1,     ---
    wr_buf.Size=2;
    wr_buf.Data[0]=0x40;     // LoadConfigSPI
    wr_buf.Data[1]=0x01;     // Low bit first, CPOL=0, CPHA=1
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," 0x40 0x01");    //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return;
                         }
    Sleep(1);
    Sleep(Delays);//////////
    //      ,       
  }
}
//---------------------------------------------------------------------------
