//---------------------------------------------------------------------------
#pragma hdrstop

#include "pic16f630.h"          //      PIC16F630 / PIC16F676 / PIC12F629 / PIC12F675
                                // PIC12F635 / PIC12F683 / PIC16F631 / PIC16F636 / PIC16F639 / PIC16F677 / PIC16F684 / PIC16F685 / PIC16F687 / PIC16F688 / PIC16F689 / PIC16F690
#include "PICFunctions.h"       //       PIC
#include "PortFunctions.h"      //      
#include "LogFunctions.h"       //      
#include "ProgressBar.h"        //   -
#include "ChipFunctions.h"      //     
#include "Main.h"               //      
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---       -------------------------
//---------------------------------------------------------------------------
bool PIC16F630_SetPCToConfigMemory(void)
{ WRITE_BUFFER wr_buf;          //    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x6");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   Load Configuration (    0x2000)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x00;          // Load Configuration
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Load Configuration");         //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //    16  ( / )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x10;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //         Load Configuration
  //     ,       Begin Programming
  wr_buf.Size=3;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x00;          // dummy byte
  wr_buf.Data[2]=0x00;          // dummy byte
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI 0x00 0x00");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////

  return true;
}
//---------------------------------------------------------------------------
//---       --------------------------
//---------------------------------------------------------------------------
bool PIC16F630_MakePCOffset(unsigned int Offset, bool PB)
{ WRITE_BUFFER wr_buf;          //    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   Increment Address   
  for(unsigned int i=0; i<Offset; i++)
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
    //      16
    if(PB)
    {   if((i+1)%8==0)
        {       LBar->ProgressBar1->Position=2*100*(i+1)/Offset;    //    -
        }
    }
  }

  return true;
}
//---------------------------------------------------------------------------
//--- /      -----------------
//---------------------------------------------------------------------------
bool PIC16F630_ReadProgramMemory(unsigned int Address, bool Action)     // /     
{ WRITE_BUFFER wr_buf;          //    
  READ_BUFFER rd_buf;           //    
  unsigned int Temp1, Temp2;    //      ,    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////

  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //   Read Data From Program Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x04;          // Read Data From Program Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Read Data From Program Memory");      //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //    16  ( / )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x10;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //      (       ,  -  -   )
  wr_buf.Size=3;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0xFE;          // dummy byte with Start bit
  wr_buf.Data[2]=0x7F;          // dummy byte with Stop bit
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI 0xFE 0x7F");        //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //     (14    -     )
  wr_buf.Size=1;
  wr_buf.Data[0]=0x4A;          // ReadSignPaket_SPI
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," ReadSignPaket_SPI");  //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   
  rd_buf=ReadFrom(2);                                   // 
  if(!rd_buf.Size) { SendMsgToLog(7," from RH-0010");   //   
                     CloseHandle(Port);
                     Port=INVALID_HANDLE_VALUE;
                     return 0;
                   }
  Temp1 = 0x3FFF & ((rd_buf.Data[0] + (rd_buf.Data[1] << 8)) >> 1);     //      ,    1         

  //---              ---
  if(!Action)   //    
  {     SelectedChip.Area1[2*Address] = Temp1;          //     
        SelectedChip.Area1[2*Address+1] = Temp1 >> 8;   //     
  }
  else          //    
  {     Temp2 = 256*SelectedChip.Area1[2*Address+1] + SelectedChip.Area1[2*Address];
        if(Temp1 != Temp2)      //      ,   
        {       return 0;       //  ,   
        }
  }
  return true;
}
//---------------------------------------------------------------------------
//--- /      --------------
//---------------------------------------------------------------------------
bool PIC16F630_ReadConfigMemory(unsigned int Address, bool Action)
{ WRITE_BUFFER wr_buf;          //    
  READ_BUFFER rd_buf;           //    
  unsigned int Temp1, Temp2;    //          

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //   Read Data From Program Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x04;          // Read Data From Program Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Read Data From Program Memory");      //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //    16  ( / )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x10;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //      (       ,  -  -   )
  wr_buf.Size=3;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0xFE;          // dummy byte with Start bit
  wr_buf.Data[2]=0x7F;          // dummy byte with Stop bit
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI 0xFE 0x7F");        //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //     (14    -     )
  wr_buf.Size=1;
  wr_buf.Data[0]=0x4A;          // ReadSignPaket_SPI
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," ReadSignPaket_SPI");  //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   
  rd_buf=ReadFrom(2);                                   // 
  if(!rd_buf.Size) { SendMsgToLog(7," from RH-0010");   //   
                     CloseHandle(Port);
                     Port=INVALID_HANDLE_VALUE;
                     return 0;
                   }
  Temp1 = 0x3FFF & ((rd_buf.Data[0] + (rd_buf.Data[1] << 8)) >> 1);     //      ,    1         

  //---              ---
  if(!Action)   //    
  {     SelectedChip.Area3[2*Address] = Temp1;          //     
        SelectedChip.Area3[2*Address+1] = Temp1 >> 8;   //     
  }
  else          //    
  {     Temp2 = 256*SelectedChip.Area3[2*Address+1] + SelectedChip.Area3[2*Address];
        if(Temp1 != Temp2)      //      ,   
        {       return 0;       //  ,   
        }
  }
  return true;
}
//---------------------------------------------------------------------------
//---           ( )
//---------------------------------------------------------------------------
bool PIC16F630_ReadConfigMemoryMask(unsigned int Address, unsigned short Mask)
{ WRITE_BUFFER wr_buf;  //    
  READ_BUFFER rd_buf;   //    
  unsigned int Temp;    //          

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //   Read Data From Program Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x04;          // Read Data From Program Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Read Data From Program Memory");      //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //    16  ( / )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x10;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //      (       ,  -  -   )
  wr_buf.Size=3;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0xFE;          // dummy byte with Start bit
  wr_buf.Data[2]=0x7F;          // dummy byte with Stop bit
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI 0xFE 0x7F");        //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //     (14    -     )
  wr_buf.Size=1;
  wr_buf.Data[0]=0x4A;          // ReadSignPaket_SPI
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," ReadSignPaket_SPI");  //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   
  rd_buf=ReadFrom(2);                                   // 
  if(!rd_buf.Size) { SendMsgToLog(7," from RH-0010");   //   
                     CloseHandle(Port);
                     Port=INVALID_HANDLE_VALUE;
                     return 0;
                   }
  // 1 -   , 0 - ,  ,     = 1
  Temp = ~Mask | ((rd_buf.Data[0] + (rd_buf.Data[1] << 8)) >> 1);     //      ,    1          

  //---        ( ) ---
  SelectedChip.Area3[2*Address] |= Temp;        //     
  SelectedChip.Area3[2*Address+1] |= Temp >> 8; //     
  return true;
}
//---------------------------------------------------------------------------
//--- /      --------------------
//---------------------------------------------------------------------------
bool PIC16F630_ReadDataMemory(unsigned int Address, bool Action)        // /     
{ WRITE_BUFFER wr_buf;          //    
  READ_BUFFER rd_buf;           //    
  unsigned int Temp;            //      ,    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////

  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //   Read Data From Data Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x05;          // Read Data From Data Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Read Data From Data Memory");      //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //    16  ( / )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x10;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //      (       ,  -  -   )
  wr_buf.Size=3;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0xFE;          // dummy byte with Start bit
  wr_buf.Data[2]=0x7F;          // dummy byte with Stop bit
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI 0xFE 0x7F");        //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //     (14    -     )
  wr_buf.Size=1;
  wr_buf.Data[0]=0x4A;          // ReadSignPaket_SPI
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," ReadSignPaket_SPI");  //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   
  rd_buf=ReadFrom(2);                                   // 
  if(!rd_buf.Size) { SendMsgToLog(7," from RH-0010");   //   
                     CloseHandle(Port);
                     Port=INVALID_HANDLE_VALUE;
                     return 0;
                   }
  Temp = 0x3FFF & ((rd_buf.Data[0] + (rd_buf.Data[1] << 8)) >> 1);      //      ,    1          

  //---              ---
  if(!Action)   //    
  {     SelectedChip.Area2[Address] = Temp;     //    
  }
  else          //    
  {     if(Temp != (unsigned int)SelectedChip.Area2[Address])   //      ,   
        {       return 0;                                       //  ,   
        }
  }
  return true;
}
//---------------------------------------------------------------------------
//***************************************************************************
//---------------------------------------------------------------------------
//---       (Int/Ext timed) -----------
//---------------------------------------------------------------------------
bool PIC16F630_WriteProgramMemory(unsigned int Address, bool Action)    //      
{ WRITE_BUFFER wr_buf;          //    
  READ_BUFFER rd_buf;           //    
  unsigned int Temp;            //      

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////

  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //      (      )
  Temp = (SelectedChip.Area1[2*Address] + (SelectedChip.Area1[2*Address+1] << 8)) << 1;
  if(Temp!=0x7FFE)              //    0x3FFF
  {     //   Load Data For Program Memory
        wr_buf.Size=2;
        wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
        wr_buf.Data[1]=0x02;          // Load Data For Program Memory
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," Load Data For Program Memory");       //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //    16  ( / )
        wr_buf.Size=2;
        wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
        wr_buf.Data[1]=0x10;          //  
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //     
        wr_buf.Size=3;
        wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
        wr_buf.Data[1]=Temp;          // Low byte with Start bit
        wr_buf.Data[2]=Temp>>8;       // High byte with Stop bit
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI Low High");        //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //    6  (  )
        wr_buf.Size=2;
        wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
        wr_buf.Data[1]=0x06;          //  
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        if(!Action)
        {     //   Begin Programming (Internally Programmed)
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x08;          // Begin Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," Begin Programming (int)");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(SelectedChip.TwrProgInt);
              Sleep(Delays);//////////
        }
        else
        {     //   Begin Programming (Externally Programmed)
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x18;          // Begin Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," Begin Programming (ext)");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(SelectedChip.TwrProgExt);
              Sleep(Delays);//////////
              //   End Programming
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x0A;          // End Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," End Programming");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(1);
              Sleep(Delays);//////////
        }
  }
  return true;
}
//---------------------------------------------------------------------------
//---       ------------------------
//---------------------------------------------------------------------------
bool PIC16F630_WriteConfigMemory(unsigned int Address, bool Action)
{ WRITE_BUFFER wr_buf;          //    
  READ_BUFFER rd_buf;           //    
  unsigned int Temp;            //      

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////

  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //      (      )
  Temp = (SelectedChip.Area3[2*Address] + (SelectedChip.Area3[2*Address+1] << 8)) << 1;
  if(Temp!=0x7FFE)              //    0x3FFF
  {     //   Load Data For Program Memory
        wr_buf.Size=2;
        wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
        wr_buf.Data[1]=0x02;          // Load Data For Program Memory
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," Load Data For Program Memory");       //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //    16  ( / )
        wr_buf.Size=2;
        wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
        wr_buf.Data[1]=0x10;          //  
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //     
        wr_buf.Size=3;
        wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
        wr_buf.Data[1]=Temp;          // low byte with Start bit
        wr_buf.Data[2]=Temp>>8;       // high byte with Stop bit
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI Low High");        //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //    6  (  )
        wr_buf.Size=2;
        wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
        wr_buf.Data[1]=0x06;          //  
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        if(!Action)
        {     //   Begin Programming (Internally Programmed)
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x08;          // Begin Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," Begin Programming (int)");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(SelectedChip.TwrProgInt);
              Sleep(Delays);//////////
        }
        else
        {     //   Begin Programming (Externally Programmed)
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x18;          // Begin Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," Begin Programming (ext)");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(SelectedChip.TwrProgExt);
              Sleep(Delays);//////////
              //   End Programming
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x0A;          // End Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," End Programming");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(1);
              Sleep(Delays);//////////
        }
  }
  return true;
}
//---------------------------------------------------------------------------
//---       ------------------------------
//---------------------------------------------------------------------------
bool PIC16F630_WriteDataMemory(unsigned int Address, bool Action)        // /     
{ WRITE_BUFFER wr_buf;          //    
  READ_BUFFER rd_buf;           //    
  unsigned int Temp;            //      

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  if(Address>0)     //       ,    
  { //   Increment Address
    wr_buf.Size=2;
    wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
    wr_buf.Data[1]=0x06;          // Increment Address
    if(!WriteTo(wr_buf)) { SendMsgToLog(6," Increment Address");        //   
                           CloseHandle(Port);
                           Port=INVALID_HANDLE_VALUE;
                           return 0;
                         }
    Sleep(1);
    Sleep(Delays);//////////
  }
  //      (      )
  Temp = (SelectedChip.Area2[Address] + (0x0 << 8)) << 1;
  if(Temp!=0x1FE)               //    0xFF
  {     //   Load Data For Data Memory
        wr_buf.Size=2;
        wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
        wr_buf.Data[1]=0x03;          // Load Data For Program Memory
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," Load Data For Data Memory");       //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //    16  ( / )
        wr_buf.Size=2;
        wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
        wr_buf.Data[1]=0x10;          //  
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //     
        wr_buf.Size=3;
        wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
        wr_buf.Data[1]=Temp;          // Low byte with Start bit
        wr_buf.Data[2]=Temp>>8;       // High byte with Stop bit
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI Low High");        //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        //    6  (  )
        wr_buf.Size=2;
        wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
        wr_buf.Data[1]=0x06;          //  
        if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                               CloseHandle(Port);
                               Port=INVALID_HANDLE_VALUE;
                               return 0;
                             }
        Sleep(1);
        Sleep(Delays);//////////
        if(!Action)
        {     //   Begin Programming (Internally Programmed)
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x08;          // Begin Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," Begin Programming (int)");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(SelectedChip.TwrDataInt);
              Sleep(Delays);//////////
        }
        else
        {     //   Begin Programming (Externally Programmed)
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x18;          // Begin Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," Begin Programming (ext)");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(SelectedChip.TwrDataExt);
              Sleep(Delays);//////////
              //   End Programming
              wr_buf.Size=2;
              wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
              wr_buf.Data[1]=0x0A;          // End Programming
              if(!WriteTo(wr_buf)) { SendMsgToLog(6," End Programming");      //   
                                     CloseHandle(Port);
                                     Port=INVALID_HANDLE_VALUE;
                                     return 0;
                                   }
              Sleep(1);
              Sleep(Delays);//////////
        }
  }
  return true;
}
//---------------------------------------------------------------------------
//---       /  -----------
//---------------------------------------------------------------------------
bool PIC16F630_LoadDataToProgramMemory(unsigned short Data)           //     
{ WRITE_BUFFER wr_buf;          //    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   Load Data For Program Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x02;          // Load Data For Program Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Load Data For Program Memory");       //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //    16  ( / )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x10;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x10");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   
  wr_buf.Size=3;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=Data<<1;       // Low byte with Start bit
  wr_buf.Data[2]=Data>>7;       // High byte with Stop bit
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," FastSendPaket_SPI Low High");        //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  return true;
}
//---------------------------------------------------------------------------
//---    /  ------------------------------
//---------------------------------------------------------------------------
bool PIC16F630_BulkEraseProgramMemory(void)      //   /
{ WRITE_BUFFER wr_buf;          //    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");    //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   Bulk Erase Program Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x09;          // Bulk Erase Program Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Bulk Erase Program Memory");        //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(SelectedChip.TerProg);
  Sleep(Delays);//////////

  return true;
}
//---------------------------------------------------------------------------
//---    ------------------------------------------------
//---------------------------------------------------------------------------
bool PIC16F630_BulkEraseDataMemory(void)      //   
{ WRITE_BUFFER wr_buf;          //    

  //    6  (  )
  wr_buf.Size=2;
  wr_buf.Data[0]=0x42;          // LoadPaketSize_SPI
  wr_buf.Data[1]=0x06;          //  
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," LoadPaketSize_SPI = 0x06");   //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(1);
  Sleep(Delays);//////////
  //   Bulk Erase Data Memory
  wr_buf.Size=2;
  wr_buf.Data[0]=0x4C;          // FastSendPaket_SPI
  wr_buf.Data[1]=0x0B;          // Bulk Erase Data Memory
  if(!WriteTo(wr_buf)) { SendMsgToLog(6," Bulk Erase Data Memory");     //   
                         CloseHandle(Port);
                         Port=INVALID_HANDLE_VALUE;
                         return 0;
                       }
  Sleep(SelectedChip.TerData);
  Sleep(Delays);//////////

  return true;
}
//---------------------------------------------------------------------------


