//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"               //      
#include "LogFunctions.h"       //      
#include "PortFunctions.h"      //      
#include "FormFunctions.h"      //     
#include "About.h"              //    About
#include "ProgressBar.h"        //   -
#include "LockFuses.h"          //    LockFusesForm
#include "Image.h"              //    ImageForm
#include "ChipFunctions.h"      //     
#include "PICFunctions.h"       //       PIC
#include "pic16f630.h"          //      PIC16F630 / PIC16F676 / PIC12F629 / PIC12F675
                                // PIC12F635 / PIC12F683 / PIC16F631 / PIC16F636 / PIC16F639 / PIC16F677 / PIC16F684 / PIC16F685 / PIC16F687 / PIC16F688 / PIC16F689 / PIC16F690
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
TForm1 *Form1;                  //  
unsigned int Delays;            //        
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void OpenPort()
{ //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  OpenCom(PortName);                            //     
  if(Port!=INVALID_HANDLE_VALUE)
  { EnableButtons();                            //   ,   Connect
    SendMsgToLog(1,AnsiString(PortName));       //  COM-
  }
}
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  DisableButtons();                     //   ,   Connect
  SendMsgToLog(3,"");                   // COM- 
}
//---------------------------------------------------------------------------
//---    -----------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ DisableButtons();                                     //   ,   Connect
  Form1->AutoSize               = true;                 //   
  Port                          = INVALID_HANDLE_VALUE; //    
  SelectedChip.ID               = 0;                    //     
  Delays = Form1->TrackBar1->Position;                  //   
}
//---------------------------------------------------------------------------
//---   COM- ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
//---   COM- ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
//---    COM- --------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
//---     EXIT ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
//---       ----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveLogas1Click(TObject *Sender)
{ AnsiString FilePath;                                  //    

  if(SaveDialog1->Execute())                            //     (  )
  { FilePath=SaveDialog1->FileName;                     //      ( )
    Form1->RichEdit5->Lines->SaveToFile(FilePath);      //      RichEdit5
    SendMsgToLog(8,FilePath);                           //      
  }
}
//---------------------------------------------------------------------------
//---     ABOUT --------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
//---     LOCK & FUSES... ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::LockFuses1Click(TObject *Sender)
{ Application->CreateForm(__classid(TLockFusesForm),&LockFusesForm);    //    
  LockFusesForm->ShowModal();                                           //     
  LockFusesForm->Free();                                                //    
}
//---------------------------------------------------------------------------
//---     RH-0010 CONNECTION... ----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RH0010Connection1Click(TObject *Sender)
{ Application->CreateForm(__classid(TImageForm),&ImageForm);        //     
  ImageForm->ShowModal();                                           //     
  ImageForm->Free();                                                //    
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEditsKeyPress(TObject *Sender, char &Key)
{  Key=0;
}
//---------------------------------------------------------------------------
//---   ID WORD -------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  

  Position=Form1->Edit2->SelStart;              //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                            //  
                if(Position<0)       Position=4;        //    <0,     
                else                                    //    >=0
                { Form1->Edit2->SelStart=Position;      //  
                  Form1->Edit2->SelLength=1;            //  1 
                  if(Position>0)        Symbol=0x46;    //    F
                  else                  Symbol=0x33;    //    3
                  Form1->Edit2->SelText=Symbol;         // 
                }
                Form1->Edit2->SelStart=Position;        //     
                Form1->Edit2->SelLength=0;              //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: if(Position>0)  Key=0x46;       //   F,      
                else            Key=0x33;       //   3,      
     //     ***********************
     default:   if(Position>3)       Position=-1;             //   >3,     
                else if(strchr(Charset1,Key))                 //          
                { Form1->Edit2->SelStart=Position;            //     
                  Form1->Edit2->SelLength=1;                  //  1 
                  if(Position==0 && Key>0x33)   Key=0x33;     //       0,1,2,3
                  Symbol=Key;
                  Form1->Edit2->SelText=Symbol;               //    
                  Form1->Edit2->SelStart=Position;            //     
                  Form1->Edit2->SelLength=1;                  //  1 
                  Form1->Edit2->SelText=UpperCase(Form1->Edit2->SelText); //      
                }
                //     
                Position+=1;                          //   
                Form1->Edit2->SelStart=Position;      //     
                Form1->Edit2->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT1 (Area 1) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, WordPos, CharPos;                 //   ,       
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit1->SelStart;            //     
  LineNumber=PositionGlobal/74;                         //  ,      72  + CR+LF
  PositionLocal=PositionGlobal-74*LineNumber;           //    
  MaxLineNumber=(FormData.RE1Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=49;                     //   <10,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<49)               //      hex
                { if ((PositionLocal-10)%5!=4)          //      
                  { //   
                    Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;     //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    if((PositionLocal-10)%5==0) Symbol=0x33;                    //    3
                    else                        Symbol=0x46;                    //    F
                    Form1->RichEdit1->SelText=Symbol;   // 
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit1->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos);//      (  )
                    Form1->RichEdit1->SelLength=2;                                      //  2 
                    SubStr=LowerCase(Form1->RichEdit1->SelText);                        //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit1->SelStart=LineNumber*74+56+2*WordPos+CharPos;      //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Form1->RichEdit1->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<56)               //       
                { PositionLocal=72;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;       //  
                  Form1->RichEdit1->SelLength=1;        //  1 
                  if((PositionLocal-56)%2==0)   Symbol=0xFF;                    //     ( )
                  else                          Symbol=0x3F;                    //    ? ( )
                  Form1->RichEdit1->SelText=Symbol;     // 
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //    
                  //   
                  Form1->RichEdit1->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //  
                  Form1->RichEdit1->SelLength=2;        //  2 
                  if(CharPos==0)        Form1->RichEdit1->SelText="FF";       //  FF
                  else                  Form1->RichEdit1->SelText="3F";       //  3F
                }
                //     
                Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;         //     
                Form1->RichEdit1->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F  3
                if((PositionLocal>9) && (PositionLocal<49))
                {       if((PositionLocal-10)%5 == 0)   Key=0x33;               //     3
                        else                            Key=0x46;               //     F
                }
                //      -     ?
                if(PositionLocal>55)
                {       if((PositionLocal-56)%2 == 0)   Key=0xFF;               //     F
                        else                            Key=0x3F;               //     ?
                }
     //     ***********************
     default:   if(PositionLocal>71)            //   > 71
                { PositionLocal=55;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>55)       //   > 55
                { //   
                  Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit1->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  if(((PositionLocal-56)%2!=0) && (Key>0x3F))   Key=0x3F;       //        0x3F
                  Symbol=Key;
                  Form1->RichEdit1->SelText=Symbol;                             //    
                  Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit1->SelLength=1;                                //  1 
                  Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText); //      
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //     (0 - , 1 - )
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit1->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //     
                  Form1->RichEdit1->SelLength=2;                                        //  2 
                  Form1->RichEdit1->SelText=OutHexBuf;
                }
                else if(PositionLocal>48)       //   >48,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 9
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%5!=4))            //          
                  { //   
                    Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit1->SelLength=1;                              //  1 
                    if(((PositionLocal-10)%5==0) && (Key > 0x33)) Key = 0x33;   //       0x3F
                    Symbol=Key;
                    Form1->RichEdit1->SelText=Symbol;                           //    
                    Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit1->SelLength=1;                              //  1 
                    Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText);     //      
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit1->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos); //      (  )
                    Form1->RichEdit1->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit1->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit1->SelStart=LineNumber*74+56+2*WordPos+CharPos;        //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Form1->RichEdit1->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit1->SelStart=LineNumber*74+PositionLocal; //     
                Form1->RichEdit1->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT2 (Area 1) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, WordPos, CharPos;                 //   ,       
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit2->SelStart;            //     
  LineNumber=PositionGlobal/74;                         //  ,      72  + CR+LF
  PositionLocal=PositionGlobal-74*LineNumber;           //    
  MaxLineNumber=(FormData.RE2Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=49;                     //   <10,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<49)               //      hex
                { if ((PositionLocal-10)%5!=4)          //      
                  { //   
                    Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;     //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    if((PositionLocal-10)%5==0) Symbol=0x33;                    //    3
                    else                        Symbol=0x46;                    //    F
                    Form1->RichEdit2->SelText=Symbol;   // 
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit2->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos);//      (  )
                    Form1->RichEdit2->SelLength=2;                                      //  2 
                    SubStr=LowerCase(Form1->RichEdit2->SelText);                        //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit2->SelStart=LineNumber*74+56+2*WordPos+CharPos;      //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Form1->RichEdit2->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<56)               //       
                { PositionLocal=72;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;       //  
                  Form1->RichEdit2->SelLength=1;        //  1 
                  if((PositionLocal-56)%2==0)   Symbol=0xFF;                    //     ( )
                  else                          Symbol=0x3F;                    //    ? ( )
                  Form1->RichEdit2->SelText=Symbol;     // 
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //    
                  //   
                  Form1->RichEdit2->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //  
                  Form1->RichEdit2->SelLength=2;        //  2 
                  if(CharPos==0)        Form1->RichEdit2->SelText="FF";       //  FF
                  else                  Form1->RichEdit2->SelText="3F";       //  3F
                }
                //     
                Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;         //     
                Form1->RichEdit2->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F  3
                if((PositionLocal>9) && (PositionLocal<49))
                {       if((PositionLocal-10)%5 == 0)   Key=0x33;               //     3
                        else                            Key=0x46;               //     F
                }
                //      -     ?
                if(PositionLocal>55)
                {       if((PositionLocal-56)%2 == 0)   Key=0xFF;               //     F
                        else                            Key=0x3F;               //     ?
                }
     //     ***********************
     default:   if(PositionLocal>71)            //   > 71
                { PositionLocal=55;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>55)       //   > 55
                { //   
                  Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit2->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  if(((PositionLocal-56)%2!=0) && (Key>0x3F))   Key=0x3F;       //        0x3F
                  Symbol=Key;
                  Form1->RichEdit2->SelText=Symbol;                             //    
                  Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit2->SelLength=1;                                //  1 
                  Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText); //      
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //     (0 - , 1 - )
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit2->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //     
                  Form1->RichEdit2->SelLength=2;                                        //  2 
                  Form1->RichEdit2->SelText=OutHexBuf;
                }
                else if(PositionLocal>48)       //   >48,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 9
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%5!=4))            //          
                  { //   
                    Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit2->SelLength=1;                              //  1 
                    if(((PositionLocal-10)%5==0) && (Key > 0x33)) Key = 0x33;   //       0x3F
                    Symbol=Key;
                    Form1->RichEdit2->SelText=Symbol;                           //    
                    Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit2->SelLength=1;                              //  1 
                    Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText);     //      
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit2->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos); //      (  )
                    Form1->RichEdit2->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit2->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit2->SelStart=LineNumber*74+56+2*WordPos+CharPos;        //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Form1->RichEdit2->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit2->SelStart=LineNumber*74+PositionLocal; //     
                Form1->RichEdit2->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT3 (Area 2) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit3->SelStart;            //     
  LineNumber=PositionGlobal/82;                         //  ,      76  + CR+LF
  PositionLocal=PositionGlobal-82*LineNumber;           //    
  MaxLineNumber=(FormData.RE3Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=57;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<57)               //      hex
                { if ((PositionLocal-10)%3!=2)           //      
                  { //   
                    Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;     //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit3->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit3->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit3->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit3->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit3->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Form1->RichEdit3->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<64)               //       
                { PositionLocal=80;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;       //  
                  Form1->RichEdit3->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit3->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  //   
                  Form1->RichEdit3->SelStart=LineNumber*82+10+3*CharPos;         //  
                  Form1->RichEdit3->SelLength=2;        //  2 
                  Form1->RichEdit3->SelText="FF";       // 
                }
                //     
                Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;         //     
                Form1->RichEdit3->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>9) && (PositionLocal<57))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>63)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>79)            //   > 43
                { PositionLocal=63;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>63)       //   > 35
                { //   
                  Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit3->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit3->SelText=Symbol;                             //    
                  Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit3->SelLength=1;                                //  1 
                  Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit3->SelStart=LineNumber*82+10+3*CharPos;         //     
                  Form1->RichEdit3->SelLength=2;                                //  2 
                  Form1->RichEdit3->SelText=OutHexBuf;
                }
                else if(PositionLocal>56)       //   >52,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%3!=2))            //          
                  { //   
                    Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit3->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit3->SelText=Symbol;                           //    
                    Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit3->SelLength=1;                              //  1 
                    Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit3->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit3->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit3->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit3->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Form1->RichEdit3->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal; //     
                Form1->RichEdit3->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT4 (Area 2) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit4KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit4->SelStart;            //     
  LineNumber=PositionGlobal/82;                         //  ,      80  + CR+LF
  PositionLocal=PositionGlobal-82*LineNumber;           //    
  MaxLineNumber=(FormData.RE4Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=57;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<57)               //      hex
                { if ((PositionLocal-10)%3!=2)           //      
                  { //   
                    Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;     //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit4->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit4->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit4->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit4->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit4->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Form1->RichEdit4->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<64)               //       
                { PositionLocal=80;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;       //  
                  Form1->RichEdit4->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit4->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  //   
                  Form1->RichEdit4->SelStart=LineNumber*82+10+3*CharPos;         //  
                  Form1->RichEdit4->SelLength=2;        //  2 
                  Form1->RichEdit4->SelText="FF";       // 
                }
                //     
                Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;         //     
                Form1->RichEdit4->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>9) && (PositionLocal<57))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>63)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>79)            //   > 43
                { PositionLocal=63;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>63)       //   > 35
                { //   
                  Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit4->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit4->SelText=Symbol;                             //    
                  Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit4->SelLength=1;                                //  1 
                  Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit4->SelStart=LineNumber*82+10+3*CharPos;         //     
                  Form1->RichEdit4->SelLength=2;                                //  2 
                  Form1->RichEdit4->SelText=OutHexBuf;
                }
                else if(PositionLocal>56)       //   >52,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%3!=2))            //          
                  { //   
                    Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit4->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit4->SelText=Symbol;                           //    
                    Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit4->SelLength=1;                              //  1 
                    Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit4->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit4->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit4->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit4->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Form1->RichEdit4->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal; //     
                Form1->RichEdit4->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT6 (Area 3) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit6KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, WordPos, CharPos;                 //   ,       
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit6->SelStart;            //     
  LineNumber=PositionGlobal/74;                         //  ,      72  + CR+LF
  PositionLocal=PositionGlobal-74*LineNumber;           //    
  MaxLineNumber=(FormData.RE6Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=49;                     //   <10,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<49)               //      hex
                { if ((PositionLocal-10)%5!=4)          //      
                  { //   
                    Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;     //  
                    Form1->RichEdit6->SelLength=1;      //  1 
                    if((PositionLocal-10)%5==0) Symbol=0x33;                    //    3
                    else                        Symbol=0x46;                    //    F
                    Form1->RichEdit6->SelText=Symbol;   // 
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit6->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos);//      (  )
                    Form1->RichEdit6->SelLength=2;                                      //  2 
                    SubStr=LowerCase(Form1->RichEdit6->SelText);                        //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit6->SelStart=LineNumber*74+56+2*WordPos+CharPos;      //  
                    Form1->RichEdit6->SelLength=1;      //  1 
                    Form1->RichEdit6->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<56)               //       
                { PositionLocal=72;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;       //  
                  Form1->RichEdit6->SelLength=1;        //  1 
                  if((PositionLocal-56)%2==0)   Symbol=0xFF;                    //     ( )
                  else                          Symbol=0x3F;                    //    ? ( )
                  Form1->RichEdit6->SelText=Symbol;     // 
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //    
                  //   
                  Form1->RichEdit6->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //  
                  Form1->RichEdit6->SelLength=2;        //  2 
                  if(CharPos==0)        Form1->RichEdit6->SelText="FF";       //  FF
                  else                  Form1->RichEdit6->SelText="3F";       //  3F
                }
                //     
                Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;         //     
                Form1->RichEdit6->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F  3
                if((PositionLocal>9) && (PositionLocal<49))
                {       if((PositionLocal-10)%5 == 0)   Key=0x33;               //     3
                        else                            Key=0x46;               //     F
                }
                //      -     ?
                if(PositionLocal>55)
                {       if((PositionLocal-56)%2 == 0)   Key=0xFF;               //     F
                        else                            Key=0x3F;               //     ?
                }
     //     ***********************
     default:   if(PositionLocal>71)            //   > 71
                { PositionLocal=55;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>55)       //   > 55
                { //   
                  Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit6->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  if(((PositionLocal-56)%2!=0) && (Key>0x3F))   Key=0x3F;       //        0x3F
                  Symbol=Key;
                  Form1->RichEdit6->SelText=Symbol;                             //    
                  Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit6->SelLength=1;                                //  1 
                  Form1->RichEdit6->SelText=UpperCase(Form1->RichEdit6->SelText); //      
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //     (0 - , 1 - )
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit6->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //     
                  Form1->RichEdit6->SelLength=2;                                        //  2 
                  Form1->RichEdit2->SelText=OutHexBuf;
                }
                else if(PositionLocal>48)       //   >48,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 9
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%5!=4))            //          
                  { //   
                    Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit6->SelLength=1;                              //  1 
                    if(((PositionLocal-10)%5==0) && (Key > 0x33)) Key = 0x33;   //       0x3F
                    Symbol=Key;
                    Form1->RichEdit6->SelText=Symbol;                           //    
                    Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit6->SelLength=1;                              //  1 
                    Form1->RichEdit6->SelText=UpperCase(Form1->RichEdit6->SelText);     //      
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit6->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos); //      (  )
                    Form1->RichEdit6->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit6->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit6->SelStart=LineNumber*74+56+2*WordPos+CharPos;        //  
                    Form1->RichEdit6->SelLength=1;      //  1 
                    Form1->RichEdit6->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit6->SelStart=LineNumber*74+PositionLocal; //     
                Form1->RichEdit6->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT7 (Area 3) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit7KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, WordPos, CharPos;                 //   ,       
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit7->SelStart;            //     
  LineNumber=PositionGlobal/74;                         //  ,      72  + CR+LF
  PositionLocal=PositionGlobal-74*LineNumber;           //    
  MaxLineNumber=(FormData.RE7Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=49;                     //   <10,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<49)               //      hex
                { if ((PositionLocal-10)%5!=4)          //      
                  { //   
                    Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;     //  
                    Form1->RichEdit7->SelLength=1;      //  1 
                    if((PositionLocal-10)%5==0) Symbol=0x33;                    //    3
                    else                        Symbol=0x46;                    //    F
                    Form1->RichEdit7->SelText=Symbol;   // 
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit7->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos);//      (  )
                    Form1->RichEdit7->SelLength=2;                                      //  2 
                    SubStr=LowerCase(Form1->RichEdit7->SelText);                        //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit7->SelStart=LineNumber*74+56+2*WordPos+CharPos;      //  
                    Form1->RichEdit7->SelLength=1;      //  1 
                    Form1->RichEdit7->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<56)               //       
                { PositionLocal=72;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;       //  
                  Form1->RichEdit7->SelLength=1;        //  1 
                  if((PositionLocal-56)%2==0)   Symbol=0xFF;                    //     ( )
                  else                          Symbol=0x3F;                    //    ? ( )
                  Form1->RichEdit7->SelText=Symbol;     // 
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //    
                  //   
                  Form1->RichEdit7->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //  
                  Form1->RichEdit7->SelLength=2;        //  2 
                  if(CharPos==0)        Form1->RichEdit7->SelText="FF";       //  FF
                  else                  Form1->RichEdit7->SelText="3F";       //  3F
                }
                //     
                Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;         //     
                Form1->RichEdit7->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F  3
                if((PositionLocal>9) && (PositionLocal<49))
                {       if((PositionLocal-10)%5 == 0)   Key=0x33;               //     3
                        else                            Key=0x46;               //     F
                }
                //      -     ?
                if(PositionLocal>55)
                {       if((PositionLocal-56)%2 == 0)   Key=0xFF;               //     F
                        else                            Key=0x3F;               //     ?
                }
     //     ***********************
     default:   if(PositionLocal>71)            //   > 71
                { PositionLocal=55;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>55)       //   > 55
                { //   
                  Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit7->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  if(((PositionLocal-56)%2!=0) && (Key>0x3F))   Key=0x3F;       //        0x3F
                  Symbol=Key;
                  Form1->RichEdit7->SelText=Symbol;                             //    
                  Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;       //     
                  Form1->RichEdit7->SelLength=1;                                //  1 
                  Form1->RichEdit7->SelText=UpperCase(Form1->RichEdit7->SelText); //      
                  //  ,   
                  WordPos=(PositionLocal-56)/2;         //    ,     
                  CharPos=(PositionLocal-56)%2;         //     (0 - , 1 - )
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit7->SelStart=LineNumber*74+10+5*WordPos+2*(1-CharPos);  //     
                  Form1->RichEdit7->SelLength=2;                                        //  2 
                  Form1->RichEdit7->SelText=OutHexBuf;
                }
                else if(PositionLocal>48)       //   >48,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 9
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%5!=4))            //          
                  { //   
                    Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit7->SelLength=1;                              //  1 
                    if(((PositionLocal-10)%5==0) && (Key > 0x33)) Key = 0x33;   //       0x3F
                    Symbol=Key;
                    Form1->RichEdit7->SelText=Symbol;                           //    
                    Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal;     //     
                    Form1->RichEdit7->SelLength=1;                              //  1 
                    Form1->RichEdit7->SelText=UpperCase(Form1->RichEdit7->SelText);     //      
                    //  ,      
                    WordPos=(PositionLocal-10)/5;        //    ,     
                    if((PositionLocal-10)%5<2)  CharPos=1;      //     ( )
                    else                        CharPos=0;      //     ( )
                    Form1->RichEdit7->SelStart=74*LineNumber+10+5*WordPos+2*(1-CharPos); //      (  )
                    Form1->RichEdit7->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit7->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit7->SelStart=LineNumber*74+56+2*WordPos+CharPos;        //  
                    Form1->RichEdit7->SelLength=1;      //  1 
                    Form1->RichEdit7->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit7->SelStart=LineNumber*74+PositionLocal; //     
                Form1->RichEdit7->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---        ,   
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadAllfromFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if(SelectedChip.ID!=0)                                      //          ROM
    { FilePath=OpenDialog1->FileName;                           //    
      NameLength=FilePath.Length();                             //      
      Ext=FilePath.SubString(NameLength-2,3);                   // 
      Ext=UpperCase(Ext);                                       //    
      if(Ext=="BIN")      LoadFromBinFileToMemory(FilePath,0);  //  ,     bin-
      else                LoadFromHexFileToMemory(FilePath,0);  //  ,     hex-  eep-
    }
    else        SendMsgToLog(14,"");                            //   
  }
}
//---------------------------------------------------------------------------
//---         ----------------
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadProgramfromFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if(SelectedChip.ID!=0)                                      //          ROM
    { FilePath=OpenDialog1->FileName;                           //    
      NameLength=FilePath.Length();                             //      
      Ext=FilePath.SubString(NameLength-2,3);                   // 
      Ext=UpperCase(Ext);                                       //    
      if(Ext=="BIN")      LoadFromBinFileToMemory(FilePath,1);  //    bin-
      else                LoadFromHexFileToMemory(FilePath,1);  //    hex-  eep-
    }
    else        SendMsgToLog(14,"");                            //   
  }
}
//---------------------------------------------------------------------------
//---         -------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if(SelectedChip.ID!=0)                                      //          ROM
    { FilePath=OpenDialog1->FileName;                           //    
      NameLength=FilePath.Length();                             //      
      Ext=FilePath.SubString(NameLength-2,3);                   // 
      Ext=UpperCase(Ext);                                       //    
      if(Ext=="BIN")      LoadFromBinFileToMemory(FilePath,2);  //    bin-
      else                LoadFromHexFileToMemory(FilePath,2);  //    hex-  eep-
    }
    else        SendMsgToLog(14,"");                            //   
  }
}
//---------------------------------------------------------------------------
//---         ------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadConfigfromFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if(SelectedChip.ID!=0)                                      //          ROM
    { FilePath=OpenDialog1->FileName;                           //    
      NameLength=FilePath.Length();                             //      
      Ext=FilePath.SubString(NameLength-2,3);                   // 
      Ext=UpperCase(Ext);                                       //    
      if(Ext=="BIN")      LoadFromBinFileToMemory(FilePath,3);  //    bin-
      else                LoadFromHexFileToMemory(FilePath,3);  //    hex-  eep-
    }
    else        SendMsgToLog(14,"");                            //   
  }
}
//---------------------------------------------------------------------------
//---        ,   
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveAlltoFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   HEX (   SaveDialog )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
    else if(SaveDialog1->FilterIndex == 2)           //   EEP (   SaveDialog )
    { if(Ext!="EEP")    FilePath = FilePath + ".eep";   //     eep -    .eep
      SelHex=true;                              //   eep-    hex-
    }
    else                                        //   BIN (   HEX   EEP,     )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)                                    //     bin
  { SaveFromMemoryToBinFile(FilePath,0);        //  ,       bin-
  }
  if(SelHex)                                    //     hex
  { SaveFromMemoryToHexFile(FilePath,0);        //  ,       hex-
  }
}
//---------------------------------------------------------------------------
//---         --------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveProgramtoFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   HEX (   SaveDialog )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
    else if(SaveDialog1->FilterIndex == 2)           //   EEP (   SaveDialog )
    { if(Ext!="EEP")    FilePath = FilePath + ".eep";   //     eep -    .eep
      SelHex=true;                              //   eep-    hex-
    }
    else                                        //   BIN (   HEX   EEP,     )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)                                    //     bin
  { SaveFromMemoryToBinFile(FilePath,1);        //      bin-
  }
  if(SelHex)                                    //     hex
  { SaveFromMemoryToHexFile(FilePath,1);        //      hex-
  }
}
//---------------------------------------------------------------------------
//---         -----------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   HEX (   SaveDialog )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
    else if(SaveDialog1->FilterIndex == 2)           //   EEP (   SaveDialog )
    { if(Ext!="EEP")    FilePath = FilePath + ".eep";   //     eep -    .eep
      SelHex=true;                              //  eep-     hex-
    }
    else                                        //   BIN (   HEX   EEP,     )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)                                    //     bin
  { SaveFromMemoryToBinFile(FilePath,2);        //      bin-
  }
  if(SelHex)                                    //     hex
  { SaveFromMemoryToHexFile(FilePath,2);        //      hex-
  }
}
//---------------------------------------------------------------------------
//---         ----------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveConfigtoFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   HEX (   SaveDialog )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
    else if(SaveDialog1->FilterIndex == 2)           //   EEP (   SaveDialog )
    { if(Ext!="EEP")    FilePath = FilePath + ".eep";   //     eep -    .eep
      SelHex=true;                              //  eep-     hex-
    }
    else                                        //   BIN (   HEX   EEP,     )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)                                    //     bin
  { SaveFromMemoryToBinFile(FilePath,3);        //      bin-
  }
  if(SelHex)                                    //     hex
  { SaveFromMemoryToHexFile(FilePath,3);        //      hex-
  }
}
//---------------------------------------------------------------------------
//---   -,    -----------
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{ Delays = Form1->TrackBar1->Position;  //    
}
//---------------------------------------------------------------------------
//////////////////////////////
//    //
//////////////////////////////
//---------------------------------------------------------------------------
//---     ------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ unsigned int ChipID;  //    ID    
  WRITE_BUFFER wr_buf;  //    
  READ_BUFFER rd_buf;   //    

  if(!SetInitState())                   //       
  {     SendMsgToLog(19," with fail."); //   false -     
        return;                         // 
  }
  if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
  {     SendMsgToLog(19," with fail."); //   false -     
        return;                         // 
  }

  ChipID = ReadSignatureBytes();        //       ,
  //---       ---
  //--- -      Vpp-last, - Vdd-last,      ,       
  //--- (    ,    -    ) ---
  if(!SetInitState())                   //        (   Vpp  Vdd)
  {     SendMsgToLog(19," with fail."); //   false -      
        return;                         // 
  }
  //---
  InitChip(ChipID);                     //      -   ,   
}
//---------------------------------------------------------------------------
//---   CHIP ERASE ----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{ if (Application->MessageBox("      All previous chip data will be lost (Program, Data, Configuration).\nYou must read and remember OSCCAL and BG-bits before this operation.\n\t        Press OK to continue or Cancel to cancel", "Warning", MB_OKCANCEL|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDOK)
  {     //        ,    
        switch(Form1->PageControl1->TabIndex)
        {       case 0: GetDataToMemory(1,1);      //  RichEdit1  Area1 - Program memory
                        GetDataToMemory(6,3);      //  RichEdit6  Area3 - Config memory
                        break;
                case 1: GetDataToMemory(2,1);      //  RichEdit2  Area1 - Program memory
                        GetDataToMemory(7,3);      //  RichEdit7  Area3 - Config memory
                        break;
                default: break;
        }

        SendMsgToLog(18," erase program, configuration and data memories");      //     
        //  -
        Application->CreateForm(__classid(TLBar),&LBar);      //    -
        LBar->Show();                                         //     

        switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
        { //   1   (CONF+9),   
          case 0x2080:  //   PIC16F887
          case 0x2060:  //   PIC16F886
          case 0x2040:  //   PIC16F884
          case 0x2020:  //   PIC16F883
          case 0x2000:  //   PIC16F882
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-words
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(8,1))      //       (   2     0x8009  0x800A)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,      
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration words (CONF + 0x0009, CONF + 0x000A) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //    
                        if(!PIC16F630_BulkEraseDataMemory())    //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        break;
          //     ,   ,     0x3FFF
          case 0x1100:  //   PIC16F648A
          case 0x1060:  //   PIC16F628A
          case 0x1040:  //   PIC16F627A
                        //     ,     
                        // 1.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //   Program Memory 0x3FFF
                        if(!PIC16F630_LoadDataToProgramMemory(0x3FFF)) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //    
                        if(!PIC16F630_BulkEraseDataMemory())    //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //       
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //      
                        SendMsgToLog(0,"    there are no calibration values in this chip");  //     
                        break;
          //   2   (CONF+9, CONF+10),   
          case 0x14A0:  //   PIC16LF1847
          case 0x1480:  //   PIC16F1847
          case 0x1BC0:  //   PIC12LF1840
          case 0x1B80:  //   PIC12F1840
          case 0x27E0:  //   PIC16F1829
          case 0x28C0:  //   PIC16LF1828
          case 0x27C0:  //   PIC16F1828
          case 0x28A0:  //   PIC16LF1827
          case 0x27A0:  //   PIC16F1827
          case 0x2880:  //   PIC16LF1826
          case 0x2780:  //   PIC16F1826
          case 0x2760:  //   PIC16F1825
          case 0x2840:  //   PIC16LF1824
          case 0x2740:  //   PIC16F1824
          case 0x2820:  //   PIC16LF1823
          case 0x2720:  //   PIC16F1823
          case 0x2800:  //   PIC12LF1822
          case 0x2700:  //   PIC12F1822
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-words
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(8,1))      //       (   2     0x8009  0x800A)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_ReadConfigMemory(10,0)) //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,      
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration words (CONF + 0x0009, CONF + 0x000A) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //    
                        if(!PIC16F630_BulkEraseDataMemory())    //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        break;
          //   2   (CONF+9, CONF+10),   
          case 0x1900:  //   PIC16LF727
          case 0x1800:  //   PIC16F727
          case 0x1940:  //   PIC16LF724
          case 0x1840:  //   PIC16F724
          case 0x1920:  //   PIC16LF726
          case 0x1820:  //   PIC16F726
          case 0x1B40:  //   PIC16LF723A
          case 0x1B00:  //   PIC16F723A
          case 0x1960:  //   PIC16LF723
          case 0x1860:  //   PIC16F723
          case 0x1B60:  //   PIC16LF722A
          case 0x1B20:  //   PIC16F722A
          case 0x1980:  //   PIC16LF722
          case 0x1880:  //   PIC16F722
          case 0x1C60:  //   PIC16LF721
          case 0x1C20:  //   PIC16F721
          case 0x1C40:  //   PIC16LF720
          case 0x1C00:  //   PIC16F720
          case 0x1AE0:  //   PIC16LF707
          case 0x1AC0:  //   PIC16F707
          case 0x2E00:  //   PIC16LF1509
          case 0x2D40:  //   PIC16F1509
          case 0x2DE0:  //   PIC16LF1508
          case 0x2D20:  //   PIC16F1508
          case 0x2DC0:  //   PIC16LF1507
          case 0x2D00:  //   PIC16F1507
          case 0x2DA0:  //   PIC16LF1503
          case 0x2CE0:  //   PIC16F1503
          case 0x2D80:  //   PIC12LF1501
          case 0x2CC0:  //   PIC12F1501
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-words
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(8,1))      //       (   2     0x8009  0x800A)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_ReadConfigMemory(10,0)) //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration words (CONF + 0x0009, CONF + 0x000A) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      ,    
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        break;
          //   2   (CONF+8, CONF+9),   ,    ID ( )
          case 0x3020:  //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       if(Form1->CheckBox1->Checked == true)       //     /      BG   
                                {       // 1.   OSCCAL-words
                                        if(!SetInitState())                   //       
                                        {       SendMsgToLog(19," with fail."); //   false -     
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                        {       SendMsgToLog(19," with fail."); //   false -     
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                        {       SendMsgToLog(19," with fail."); //   false -     
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        if(!PIC16F630_MakePCOffset(7,1))      //       (   2     0x2008  0x2009)
                                        {       SendMsgToLog(19," with fail."); //   false -     
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        //      
                                        if(!PIC16F630_ReadConfigMemory(8,0))  //     
                                        {       SendMsgToLog(19," with fail."); //   false -   
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                        {       SendMsgToLog(19," with fail."); //   false -   
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        //--- -      Vpp-last, - Vdd-last,  
                                        //---    ,       
                                        if(!SetInitState())                   //        (   Vpp  Vdd)
                                        {       SendMsgToLog(19," with fail."); //   false -     
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        SendMsgToLog(0,"    calibration words (0x2008, 0x2009) has been read and stored");  //     
                                }
                                // 2.   , .   -   
                                if(!SetInitState())                   //       
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      
                                if(!PIC16F630_BulkEraseProgramMemory()) //    
                                {       SendMsgToLog(19," with fail."); //   false - 
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //     ,       
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //         ,     
                                //  bulk erase    (    )
                                SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                        }
                        break;
          //   2   (CONF+8, CONF+9),   
          case 0x1500:  //   PIC12F752
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-words
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(7,1))      //       (   2     0x2008  0x2009)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(8,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration words (0x2008, 0x2009) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ,       
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        break;
          //   1   (CONF+8),   
          case 0x1240:  //   PIC16F616
          case 0x2260:  //   PIC16F610
          case 0x2240:  //   PIC12F609
          case 0x1360:  //   PIC12F617
          case 0x2180:  //   PIC12F615
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-word
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(7,1))      //       (   2     0x2008  0x2009)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(8,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration word (CONF + 0x0008) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     , ..     
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration value for this chip");  //     
                        break;
          //   1   (CONF+8),   
          case 0x1400:  //   PIC16F690
          case 0x1340:  //   PIC16F689
          case 0x1180:  //   PIC16F688
          case 0x1320:  //   PIC16F687
          case 0x04A0:  //   PIC16F685
          case 0x1080:  //   PIC16F684
          case 0x1440:  //   PIC16F677
          case 0x1420:  //   PIC16F631
          case 0x0460:  //   PIC12F683
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-word
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(7,1))      //       (   2     0x2008  0x2009)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(8,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration word (0x2008) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //    
                        if(!PIC16F630_BulkEraseDataMemory())    //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration value for this chip");  //     
                        break;
          //   2   (CONF+8, CONF+9),   
          case 0x1200:  //   PIC16F785
          case 0x10A0:  //   PIC16F636 / PIC16F639
          case 0x0FA0:  //   PIC12F635
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-words
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(7,1))      //       (   2     0x2008  0x2009)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(8,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    calibration words (CONF + 0x0008, CONF + 0x0009) has been read and stored");  //     
                        }
                        // 2.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //    
                        if(!PIC16F630_BulkEraseDataMemory())    //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        //         ,     
                        //  bulk erase    (    )
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        break;
          //   1   (   ),   
          //    2       
          case 0x10C0:  //   PIC16F630
          case 0x10E0:  //   PIC16F676
          case 0x0F80:  //   PIC12F629
          case 0x0FC0:  //   PIC12F675
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 1.   OSCCAL-word
                                if(!SetInitState())                   //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(SelectedChip.Area1Size/2-2,1))   //       (  -   )
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadProgramMemory(SelectedChip.Area1Size/2-1,0))    //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                // 2.   BG-bits
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(6,1))          //       (7-1=6),          
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemoryMask(7,0x3000)) //       7 (0x2007)   0x3000 (BG-bits)
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                SendMsgToLog(0,"    OSCCAL word & BG-bits has been read and stored");  //     
                        }
                        // 3.   ,   
                        if(!SetInitState())                   //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory ( ,    )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_BulkEraseProgramMemory()) //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //    
                        if(!PIC16F630_BulkEraseDataMemory())    //    
                        {       SendMsgToLog(19," with fail."); //   false - 
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {     SendMsgToLog(19," with fail."); //   false -     
                              LBar->Free();                   //    -
                              return;                         // 
                        }
                        if(Form1->CheckBox1->Checked == true)       //     /      BG   
                        {       // 4.        OSCCAL)
                                if(!SetInitState())                     //       
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(SelectedChip.Area1Size/2-2,1))   //       (  -   )
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //      
                                if(!PIC16F630_WriteProgramMemory(SelectedChip.Area1Size/2-1,0))    //     
                                {     SendMsgToLog(19," with fail."); //   false -   
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {     SendMsgToLog(19," with fail."); //   false -     
                                      LBar->Free();                   //    -
                                      return;                         // 
                                }
                                // 5.   BG-bits
                                if(!SetInitState())                     //       
                                {   SendMsgToLog(19," with fail."); //   false -     
                                    LBar->Free();                   //    -
                                    return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                                {   SendMsgToLog(19," with fail."); //   false -     
                                    LBar->Free();                   //    -
                                    return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {   SendMsgToLog(19," with fail."); //   false -     
                                    LBar->Free();                   //    -
                                    return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(6,1))          //       (7-1=6),          
                                {   SendMsgToLog(19," with fail."); //   false -     
                                    LBar->Free();                   //    -
                                    return;                         // 
                                }
                                //      
                                if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (0x2007)
                                {   SendMsgToLog(19," with fail."); //   false -   
                                    LBar->Free();                   //    -
                                    return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {   SendMsgToLog(19," with fail."); //   false -     
                                    LBar->Free();                   //    -
                                    return;                         // 
                                }
                                SendMsgToLog(0,"    OSCCAL word & BG-bits has been restored");  //     
                        }
                        break;
          case 0:  SendMsgToLog(14,"");            //   ,      
                   break;                          // 
          default: SendMsgToLog(15," unknown");    //   ,      
                   break;                          // 
        }
        LBar->Free();                   //    -
        SendMsgToLog(19,"");  //    
  }
  else  SendMsgToLog(0,"Operation cancelled");  //    
}
//---------------------------------------------------------------------------
//---   READ OSCCAL ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{ //        ,    
  switch(Form1->PageControl1->TabIndex)
  {     case 0: GetDataToMemory(1,1);      //  RichEdit1  Area1
                GetDataToMemory(6,3);      //  RichEdit6  Area3
                break;
        case 1: GetDataToMemory(2,1);      //  RichEdit2  Area1
                GetDataToMemory(7,3);      //  RichEdit7  Area3
                break;
        default: break;
  }

  SendMsgToLog(18," read factory calibrated values");   //      

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();

  //     
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { //         CONF+9
    case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_MakePCOffset(8,1))        //      
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     
                        if(!PIC16F630_ReadConfigMemory(9,0))    //     (CONF + 0x0009)
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    //       
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
                        SendMsgToLog(15,"       there are no calibration values in this chip");   //   ,      
                        break;                          // 
    //          CONF+9, CONF+10
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC16F1508
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_MakePCOffset(8,1))        //       (     )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_ReadConfigMemory(9,0))    //      (CONF + 0x0009)
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        if(!PIC16F630_ReadConfigMemory(10,0))   //      (CONF + 0x000A)
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    //         CONF+8
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x1360:        //   PIC12F617
    case 0x2180:        //   PIC12F615
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_MakePCOffset(7,1))        //      
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_ReadConfigMemory(8,0))    //     
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    //         CONF+8, CONF+9,    -    ID - ,  
    case 0x3020:     //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       if(!SetInitState())                     //       
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(7,1))        //       (     )
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(8,0))    //     
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        return;                         // 
                                }
                                if(!PIC16F630_ReadConfigMemory(9,0))    //     
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                        }
                        break;
    //         CONF+8, CONF+9
    case 0x1200:        //   PIC16F785
    case 0x1500:        //   PIC12F752
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x0FA0:        //   PIC12F635
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_MakePCOffset(7,1))        //       (     )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_ReadConfigMemory(8,0))    //     
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        if(!PIC16F630_ReadConfigMemory(9,0))    //     
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    //          ,       
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!PIC16F630_MakePCOffset(SelectedChip.Area1Size/2-2,1))   //       (  -   )
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!PIC16F630_ReadProgramMemory(SelectedChip.Area1Size/2-1,0))    //     
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                return;                         // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                break;                          // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                break;                          // 
  }
  LBar->Free();                   //    -
  //  PlaceDataToForm   ,      -  
  //       (   )
  switch(Form1->PageControl1->TabIndex)
  {     case 0: PlaceDataToForm(1,1);      //  RichEdit1  Area1
                PlaceDataToForm(6,3);      //  RichEdit6  Area3
                break;
        case 1: PlaceDataToForm(2,1);      //  RichEdit2  Area1
                PlaceDataToForm(7,3);      //  RichEdit7  Area3
                break;
        default: break;
  }
  SendMsgToLog(19,"");  //    
}
//---------------------------------------------------------------------------
//---   VERIFY PROGRAM & CONFIG MEMORY --------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];        //  
  AnsiString TempStr;                   //     

  //        ,    
  switch(Form1->PageControl1->TabIndex)
  {       case 0: GetDataToMemory(1,1);      //  RichEdit1  Area1
                  GetDataToMemory(6,3);      //  RichEdit6  Area3
                  break;
          case 1: GetDataToMemory(2,1);      //  RichEdit2  Area1
                  GetDataToMemory(7,3);      //  RichEdit7  Area3
                  break;
          default: break;
  }

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," verify the program memory");       //     
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { case 0x3020:        //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       // 1.   
                                if(!SetInitState())                     //       
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //       
                                for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                                {       if(!PIC16F630_ReadProgramMemory(i,1))           //    
                                        {       TempBuf[0]=i>>8;                        //    
                                                BinToHex(TempBuf,OutHexBuf,1);          //   
                                                OutHexBuf[2]=0;                         //    
                                                TempStr=UpperCase(OutHexBuf);           //        
                                                TempBuf[0]=i;                           //    
                                                BinToHex(TempBuf,OutHexBuf,1);          //   
                                                OutHexBuf[2]=0;                         //    
                                                TempStr+=UpperCase(OutHexBuf);          //        

                                                SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                                SendEndTimeToLog();                                     //      
                                                LBar->Free();                                           //    -
                                                return;                                                 // 
                                        }
                                        //      8
                                        if((i+1)%8==0)
                                        {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                                        }
                                }
                                // 2.   
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //       
                                for(unsigned int i=0; i<SelectedChip.Area3Size/2; i++)  //   
                                {       if(!PIC16F630_ReadConfigMemory(i,1))            //    
                                        {       TempBuf[0]=(i+SelectedChip.ConfigStart)>>8;     //    
                                                BinToHex(TempBuf,OutHexBuf,1);          //   
                                                OutHexBuf[2]=0;                         //    
                                                TempStr=UpperCase(OutHexBuf);           //        
                                                TempBuf[0]=(i+SelectedChip.ConfigStart);        //    
                                                BinToHex(TempBuf,OutHexBuf,1);          //   
                                                OutHexBuf[2]=0;                         //    
                                                TempStr+=UpperCase(OutHexBuf);          //        

                                                SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                                SendEndTimeToLog();                                     //      
                                                LBar->Free();                                           //    -
                                                return;                                                 // 
                                        }
                                        //      8
                                        if((i+1)%8==0)
                                        {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                        }
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,       
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
    case 0x1200:        //   PIC16F785
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x1360:        //   PIC12F617
    case 0x2180:        //   PIC12F615
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC16F1508
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
    case 0x1500:        //   PIC12F752
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
    case 0x0FA0:        //   PIC12F635
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        // 1.   
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //       
                        for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                        {       if(!PIC16F630_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        // 2.   
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //       
                        for(unsigned int i=0; i<SelectedChip.Area3Size/2; i++)  //   
                        {       if(!PIC16F630_ReadConfigMemory(i,1))            //    
                                {       TempBuf[0]=(i+SelectedChip.ConfigStart)>>8;     //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=(i+SelectedChip.ConfigStart);        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -
  SendMsgToLog(19,". No differences found.");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---   VERIFY DATA ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];        //  
  AnsiString TempStr;                   //     

  //        ,    
  switch(Form1->PageControl1->TabIndex)
  {       case 0: GetDataToMemory(3,2);      //  RichEdit3  Area2
                  break;
          case 1: GetDataToMemory(4,2);      //  RichEdit4  Area2
                  break;
          default: break;
  }

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," verify the data memory");        //     EEPROM
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { //     EEPROM
    case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
    case 0x1200:        //   PIC16F785
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
    case 0x0FA0:        //   PIC12F635
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!PIC16F630_ReadDataMemory(i,1))              //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      16
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,       
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x3020:        //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       SendMsgToLog(0,"function is unavailable for this chip");        //   ,   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;
                        }
                        //break; - ,       
    //     EEPROM
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x1360:        //   PIC12F617
    case 0x2180:        //   PIC12F615
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC16F1508
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
    case 0x1500:        //   PIC12F752
                SendMsgToLog(0,"function is unavailable for this chip");        //   ,   
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -
  SendMsgToLog(19,". No differences found.");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---   WRITE PROGRAM & CONFIG MEMORY ---------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{ if (Application->MessageBox("Previous data in the Program & Config memory (& maybe in Data memory too) will be lost!\n            Are you sure?", "Warning", MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDYES)
  { //        ,    
    switch(Form1->PageControl1->TabIndex)
    {       case 0: GetDataToMemory(1,1);      //  RichEdit1  Area1 - Program memory
                    GetDataToMemory(6,3);      //  RichEdit6  Area3 - Config memory
                    break;
            case 1: GetDataToMemory(2,1);      //  RichEdit2  Area1 - Program memory
                    GetDataToMemory(7,3);      //  RichEdit7  Area3 - Config memory
                    break;
            default: break;
    }

    if(Form1->CheckBox2->Checked == true)
    {   SendMsgToLog(18," write the program memory & entire config memory");    //         
    }
    else
    {   SendMsgToLog(18," write the program memory & config word");     //        
    }

    SendStartTimeToLog();                         //      
    //  -
    Application->CreateForm(__classid(TLBar),&LBar);      //    -
    LBar->Show();

    switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
    { //      CONF7, CONF8,      CONF9
      //    9 ,   -  
      case 0x2080:  //   PIC16F887
      case 0x2060:  //   PIC16F886
      case 0x2040:  //   PIC16F884
      case 0x2020:  //   PIC16F883
      case 0x2000:  //   PIC16F882
                    if(Form1->CheckBox1->Checked == true)       //     /   
                    {     // 1.   OSCCAL-words
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                          {       SendMsgToLog(19," with fail."); //   false -     
                                  LBar->Free();                   //    -
                                  return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(8,1))      //       (     0x2009)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemory(9,0))  //    
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,      
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    calibration words (CONF + 0x0009) has been read and stored");  //     
                    }
                    // 2.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 3.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,0))          //     (int timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 4.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //      (OSCCAL   )
                    {   for(unsigned int i=0; i<9; i++)                 //    (  9 ,     ,        erase,    )
                        {       if(!PIC16F630_WriteConfigMemory(i,0))   //       (int timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (CONF + 0x0007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        if(!PIC16F630_WriteConfigMemory(8,0))   //       8 (CONF + 0x0008)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7,   , int timing
      case 0x1100:  //   PIC16F648A
      case 0x1060:  //   PIC16F628A
      case 0x1040:  //   PIC16F627A
                    // 1.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    //   Program Memory 0x3FFF
                    if(!PIC16F630_LoadDataToProgramMemory(0x3FFF)) //    
                    {       SendMsgToLog(19," with fail."); //   false - 
                            LBar->Free();                   //    -
                            return;                         // 
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,       
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 2.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,0))        //     (int timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 3.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //     
                    {   for(unsigned int i=0; i<8; i++)                 //    (  8 ,      )
                        {       if(!PIC16F630_WriteConfigMemory(i,0))   //       (int timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration value for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (0x2007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,       
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7, CONF8,      CONF9, CONF10
      //    9 ,   -  
      case 0x1900:  //   PIC16LF727
      case 0x1800:  //   PIC16F727
      case 0x1940:  //   PIC16LF724
      case 0x1840:  //   PIC16F724
      case 0x1920:  //   PIC16LF726
      case 0x1820:  //   PIC16F726
      case 0x1B40:  //   PIC16LF723A
      case 0x1B00:  //   PIC16F723A
      case 0x1960:  //   PIC16LF723
      case 0x1860:  //   PIC16F723
      case 0x1B60:  //   PIC16LF722A
      case 0x1B20:  //   PIC16F722A
      case 0x1980:  //   PIC16LF722
      case 0x1880:  //   PIC16F722
      case 0x1C60:  //   PIC16LF721
      case 0x1C20:  //   PIC16F721
      case 0x1C40:  //   PIC16LF720
      case 0x1C00:  //   PIC16F720
      case 0x1AE0:  //   PIC16LF707
      case 0x1AC0:  //   PIC16F707
      case 0x14A0:  //   PIC16LF1847
      case 0x1480:  //   PIC16F1847
      case 0x1BC0:  //   PIC12LF1840
      case 0x1B80:  //   PIC12F1840
      case 0x28E0:  //   PIC16LF1829
      case 0x27E0:  //   PIC16F1829
      case 0x28C0:  //   PIC16LF1828
      case 0x27C0:  //   PIC16F1828
      case 0x28A0:  //   PIC16LF1827
      case 0x27A0:  //   PIC16F1827
      case 0x2880:  //   PIC16LF1826
      case 0x2780:  //   PIC16F1826
      case 0x2860:  //   PIC16LF1825
      case 0x2760:  //   PIC16F1825
      case 0x2840:  //   PIC16LF1824
      case 0x2740:  //   PIC16F1824
      case 0x2820:  //   PIC16LF1823
      case 0x2720:  //   PIC16F1823
      case 0x2800:  //   PIC12LF1822
      case 0x2700:  //   PIC16F1822
      case 0x2E00:  //   PIC16LF1509
      case 0x2D40:  //   PIC16F1509
      case 0x2DE0:  //   PIC16LF1508
      case 0x2D20:  //   PIC16F1508
      case 0x2DC0:  //   PIC16LF1507
      case 0x2D00:  //   PIC16F1507
      case 0x2DA0:  //   PIC16LF1503
      case 0x2CE0:  //   PIC16F1503
      case 0x2D80:  //   PIC12LF1501
      case 0x2CC0:  //   PIC12F1501
                    if(Form1->CheckBox1->Checked == true)       //     /   
                    {     // 1.   OSCCAL-words
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                          {       SendMsgToLog(19," with fail."); //   false -     
                                  LBar->Free();                   //    -
                                  return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(8,1))      //       (     0x2009)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemory(9,0))  //    
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_ReadConfigMemory(10,0)) //    
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,      
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    calibration words (CONF + 0x0009, CONF + 0x000A) has been read and stored");  //     
                    }
                    // 2.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,       
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 3.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,0))          //     (int timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 4.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //      (OSCCAL   )
                    {   for(unsigned int i=0; i<9; i++)                 //    (  9 ,     ,        erase,    )
                        {       if(!PIC16F630_WriteConfigMemory(i,0))   //       (int timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (CONF + 0x0007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        if(!PIC16F630_WriteConfigMemory(8,0))   //       8 (CONF + 0x0008)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7,      CONF8
      //    8 ,   -  
      case 0x1240:  //   PIC16F616
      case 0x2260:  //   PIC16F610
      case 0x2240:  //   PIC12F609
      case 0x1360:  //   PIC12F617
      case 0x2180:  //   PIC12F615
                    if(Form1->CheckBox1->Checked == true)       //     /   
                    {     // 1.   OSCCAL-word
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                          {       SendMsgToLog(19," with fail."); //   false -     
                                  LBar->Free();                   //    -
                                  return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(7,1))      //       (    0x2008)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemory(8,0))  //    
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,       
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    calibration word (0x2008) has been read and stored");  //     
                    }
                    // 2.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,       
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 3.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,1))        //     (ext timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 4.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //     
                    {   for(unsigned int i=0; i<8; i++)                 //    (  8 ,     ,        erase,    )
                        {       if(!PIC16F630_WriteConfigMemory(i,1))   //       (ext timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration value for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,1))   //       7 (0x2007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7,      CONF8
      //    8 ,   -  
      case 0x1400:  //   PIC16F690
      case 0x1340:  //   PIC16F689
      case 0x1180:  //   PIC16F688
      case 0x1320:  //   PIC16F687
      case 0x04A0:  //   PIC16F685
      case 0x1080:  //   PIC16F684
      case 0x1440:  //   PIC16F677
      case 0x1420:  //   PIC16F631
      case 0x0460:  //   PIC12F683
                    if(Form1->CheckBox1->Checked == true)       //     /   
                    {     // 1.   OSCCAL-word
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                          {       SendMsgToLog(19," with fail."); //   false -     
                                  LBar->Free();                   //    -
                                  return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(7,1))      //       (    0x2008)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemory(8,0))  //    
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,       
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    calibration word (0x2008) has been read and stored");  //     
                    }
                    // 2.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 3.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,0))        //     (int timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 4.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //     
                    {   for(unsigned int i=0; i<8; i++)                 //    (  8 ,     ,        erase,    )
                        {       if(!PIC16F630_WriteConfigMemory(i,0))   //       (int timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration value for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (0x2007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7,      CONF8, CONF9
      //    8 ,   -  
      case 0x3020:  //   PIC16F753
                    if(SelectedChip.ID == 0x3030)       //    PIC16F753
                    {   if(Form1->CheckBox1->Checked == true)       //     /   
                        {       // 1.   OSCCAL-words
                                if(!SetInitState())                   //       
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!PIC16F630_MakePCOffset(7,1))      //       (     0x2008)
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      
                                if(!PIC16F630_ReadConfigMemory(8,0))  //     
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!PIC16F630_ReadConfigMemory(9,0))  //     
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,      
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                SendMsgToLog(0,"    calibration words (0x2008, 0x2009) has been read and stored");  //     
                        }
                        // 2.     (   )
                        if(!SetInitState())                 //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(Form1->CheckBox2->Checked == true)       //       
                        {       if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {       SendMsgToLog(19," with fail.");     //   false -     
                                        LBar->Free();                       //    -
                                        return;                             // 
                                }
                        }
                        if(!PIC16F630_BulkEraseProgramMemory())     //    
                        {       SendMsgToLog(19," with fail.");         //   false -     
                                LBar->Free();                           //    -
                                return;                                 // 
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // 3.   
                        if(!SetInitState())                 //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                        {       if(!PIC16F630_WriteProgramMemory(i,1))        //     (ext timing)
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        // 4.       
                        if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(Form1->CheckBox2->Checked == true) //      (    OSCCAL)
                        {       for(unsigned int i=0; i<8; i++)                 //    (  8 ,     ,        erase,    )
                                {       if(!PIC16F630_WriteConfigMemory(i,1))   //       (ext timing)
                                        {       SendMsgToLog(19," with fail."); //   false -   
                                                SendEndTimeToLog();             //      
                                                LBar->Free();                   //    -
                                                return;                         // 
                                        }
                                        //      8
                                        if((i+1)%8==0)
                                        {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                        }
                                }
                                SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                        }
                        else                                    //     
                        {       if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      
                                if(!PIC16F630_WriteConfigMemory(7,1))   //       7 (0x2007)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                    }
                    else
                    {   SendMsgToLog(15," unknown");    //   ,      
                        LBar->Free();                   //    -
                        SendEndTimeToLog();             //      
                        return;                         // 
                    }
                    break;
      //      CONF7,      CONF8, CONF9
      //    8 ,   -  
      case 0x1500:  //   PIC12F752
                    if(Form1->CheckBox1->Checked == true)       //     /   
                    {     // 1.   OSCCAL-words
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                          {       SendMsgToLog(19," with fail."); //   false -     
                                  LBar->Free();                   //    -
                                  return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(7,1))      //       (     0x2008)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemory(8,0))  //     
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_ReadConfigMemory(9,0))  //     
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,      
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    calibration words (0x2008, 0x2009) has been read and stored");  //     
                    }
                    // 2.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 3.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,1))        //     (ext timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 4.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //      (    OSCCAL)
                    {   for(unsigned int i=0; i<8; i++)                 //    (  8 ,     ,        erase,    )
                        {       if(!PIC16F630_WriteConfigMemory(i,1))   //       (ext timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,1))   //       7 (0x2007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7,      CONF8, CONF9
      //    8 ,   -  
      case 0x1200:  //   PIC16F785
      case 0x10A0:  //   PIC16F636 / PIC16F639
      case 0x0FA0:  //   PIC12F635
                    if(Form1->CheckBox1->Checked == true)       //     /   
                    {     // 1.   OSCCAL-words
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                          {       SendMsgToLog(19," with fail."); //   false -     
                                  LBar->Free();                   //    -
                                  return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(7,1))      //       (     0x2008)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemory(8,0))  //     
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_ReadConfigMemory(9,0))  //     
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,      
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    calibration words (0x2008, 0x2009) has been read and stored");  //     
                    }
                    // 2.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 3.   
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,0))          //     (int timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 4.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //      (    OSCCAL)
                    {   for(unsigned int i=0; i<8; i++)                 //    (  8 ,     ,        erase,    )
                        {       if(!PIC16F630_WriteConfigMemory(i,0))   //       (int timing)
                                {       SendMsgToLog(19," with fail."); //   false -   
                                        SendEndTimeToLog();             //      
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        SendMsgToLog(0,"    there is no need to restore the calibration values for this chip");  //     
                    }
                    else                                    //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (0x2007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    break;
      //      CONF7,      PROGEND
      //    8 ,   -  
      case 0x10C0:  //   PIC16F630
      case 0x10E0:  //   PIC16F676
      case 0x0F80:  //   PIC12F629
      case 0x0FC0:  //   PIC12F675
                    if(Form1->CheckBox1->Checked == true)       //     /      BG   
                    {     // 1.   OSCCAL-word
                          if(!SetInitState())                   //       
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!EnterHVPVMode_VPPfirst())         //        Vpp-first
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(SelectedChip.Area1Size/2-2,1))     //       (  -   )
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadProgramMemory(SelectedChip.Area1Size/2-1,0)) //     
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          // 2.   BG-bits
                          if(!PIC16F630_SetPCToConfigMemory())  //     Config Memory
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          if(!PIC16F630_MakePCOffset(6,1))      //       (7-1=6),          
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //      
                          if(!PIC16F630_ReadConfigMemoryMask(7,0x3000)) //       7 (0x2007)   0x3000 (BG-bits)
                          {     SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          //--- -      Vpp-last, - Vdd-last,   
                          //---   ,      
                          if(!SetInitState())                   //        (   Vpp  Vdd)
                          {     SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                          }
                          SendMsgToLog(0,"    OSCCAL word & BG-bits has been read and stored");  //     
                    }
                    // 3.     (   )
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true)       //       
                    {   if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {   SendMsgToLog(19," with fail.");     //   false -     
                            LBar->Free();                       //    -
                            return;                             // 
                        }
                    }
                    if(!PIC16F630_BulkEraseProgramMemory())     //    
                    {   SendMsgToLog(19," with fail.");         //   false -     
                        LBar->Free();                           //    -
                        return;                                 // 
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {     SendMsgToLog(19," with fail."); //   false -     
                          LBar->Free();                   //    -
                          return;                         // 
                    }
                    // 4.    (    OSCCAL)
                    if(!SetInitState())                 //       
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(!EnterHVPVMode_VPPfirst())       //        Vpp-first
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                    {     if(!PIC16F630_WriteProgramMemory(i,0))          //     (int timing)
                          {     SendMsgToLog(19," with fail.");         //   false -   
                                LBar->Free();                           //    -
                                return;                                 // 
                          }
                          //      8
                          if((i+1)%8==0)
                          {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                          }
                     }
                    // 5.       
                    if(!PIC16F630_SetPCToConfigMemory()) //     Config Memory
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox2->Checked == true) //     
                    {   for(unsigned int i=0; i<SelectedChip.Area3Size/2; i++)  //   
                        {       if(!PIC16F630_WriteConfigMemory(i,0))           //       (int timing)
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                    }
                    else                                  //     
                    {   if(!PIC16F630_MakePCOffset(6,1))    //       (7-1=6),          
                        {   SendMsgToLog(19," with fail."); //   false -     
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                        //      
                        if(!PIC16F630_WriteConfigMemory(7,0))   //       7 (0x2007)
                        {   SendMsgToLog(19," with fail."); //   false -   
                            LBar->Free();                   //    -
                            return;                         // 
                        }
                    }
                    //--- -      Vpp-last, - Vdd-last,   
                    //---   ,      
                    if(!SetInitState())                   //        (   Vpp  Vdd)
                    {   SendMsgToLog(19," with fail."); //   false -     
                        LBar->Free();                   //    -
                        return;                         // 
                    }
                    if(Form1->CheckBox1->Checked == true) //    ,       
                    {   SendMsgToLog(0,"    OSCCAL & BG-bits has been restored");  //     
                    }
                    break;
      case 0:   SendMsgToLog(14,"");            //   ,      
                LBar->Free();                   //    -
                SendEndTimeToLog();             //      
                return;                         // 
      default:  SendMsgToLog(15," unknown");    //   ,      
                LBar->Free();                   //    -
                SendEndTimeToLog();             //      
                return;                         // 
    }
    LBar->Free();         //    -
    //  PlaceDataToForm   ,      -  
    //          
    switch(Form1->PageControl1->TabIndex)
    {       case 0: PlaceDataToForm(1,1);      //  RichEdit1  Area1 - Program memory
                    PlaceDataToForm(6,3);      //  RichEdit6  Area3 - Config memory
                    break;
            case 1: PlaceDataToForm(2,1);      //  RichEdit2  Area1 - Program memory
                    PlaceDataToForm(7,3);      //  RichEdit7  Area3 - Config memory
                    break;
            default: break;
    }
    SendMsgToLog(19,"");  //    
    SendEndTimeToLog();   //      
  }
  else  SendMsgToLog(0,"Operation cancelled");         //    
}
//---------------------------------------------------------------------------
//---   WRITE DATA MEMORY ---------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{ if (Application->MessageBox("Previous data in the Data memory will be lost!\n            Are you sure?", "Warning", MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDYES)
  { //        ,    
    switch(Form1->PageControl1->TabIndex)
    {   case 0: GetDataToMemory(3,2);      //  RichEdit3  Area2
                break;
        case 1: GetDataToMemory(4,2);      //  RichEdit4  Area2
                break;
        default: break;
    }

    //  -
    Application->CreateForm(__classid(TLBar),&LBar);    //    -
    LBar->Show();                                       //     

    SendMsgToLog(18," write the data memory");          //     EEPROM
    SendStartTimeToLog();                    //      
    switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
    { //     EEPROM, int timing  
      case 0x2080:      //   PIC16F887
      case 0x2060:      //   PIC16F886
      case 0x2040:      //   PIC16F884
      case 0x2020:      //   PIC16F883
      case 0x2000:      //   PIC16F882
      case 0x1100:      //   PIC16F648A
      case 0x1060:      //   PIC16F628A
      case 0x1040:      //   PIC16F627A
      case 0x1200:      //   PIC16F785
      case 0x14A0:      //   PIC16LF1847
      case 0x1480:      //   PIC16F1847
      case 0x1BC0:      //   PIC12LF1840
      case 0x1B80:      //   PIC12F1840
      case 0x28E0:      //   PIC16LF1829
      case 0x27E0:      //   PIC16F1829
      case 0x28C0:      //   PIC16LF1828
      case 0x27C0:      //   PIC16F1828
      case 0x28A0:      //   PIC16LF1827
      case 0x27A0:      //   PIC16F1827
      case 0x2880:      //   PIC16LF1826
      case 0x2780:      //   PIC16F1826
      case 0x2860:      //   PIC16LF1825
      case 0x2760:      //   PIC16F1825
      case 0x2840:      //   PIC16LF1824
      case 0x2740:      //   PIC16F1824
      case 0x2820:      //   PIC16LF1823
      case 0x2720:      //   PIC16F1823
      case 0x2800:      //   PIC12LF1822
      case 0x2700:      //   PIC12F1822
      case 0x1400:      //   PIC16F690
      case 0x1340:      //   PIC16F689
      case 0x1180:      //   PIC16F688
      case 0x1320:      //   PIC16F687
      case 0x04A0:      //   PIC16F685
      case 0x1080:      //   PIC16F684
      case 0x1440:      //   PIC16F677
      case 0x10A0:      //   PIC16F636 / PIC16F639
      case 0x1420:      //   PIC16F631
      case 0x0460:      //   PIC12F683
      case 0x0FA0:      //   PIC12F635
      case 0x10C0:      //   PIC16F630
      case 0x10E0:      //   PIC16F676
      case 0x0F80:      //   PIC12F629
      case 0x0FC0:      //   PIC12F675
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)    //   
                        {       if(!PIC16F630_WriteDataMemory(i,0))             //     (int timing)
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      16
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
      case 0x3020:        //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       SendMsgToLog(0,"function is unavailable for this chip");        //   ,   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;
                        }
                        //break; - ,       
      //     EEPROM
      case 0x1900:        //   PIC16LF727
      case 0x1800:        //   PIC16F727
      case 0x1940:        //   PIC16LF724
      case 0x1840:        //   PIC16F724
      case 0x1920:        //   PIC16LF726
      case 0x1820:        //   PIC16F726
      case 0x1B40:        //   PIC16LF723A
      case 0x1B00:        //   PIC16F723A
      case 0x1960:        //   PIC16LF723
      case 0x1860:        //   PIC16F723
      case 0x1B60:        //   PIC16LF722A
      case 0x1B20:        //   PIC16F722A
      case 0x1980:        //   PIC16LF722
      case 0x1880:        //   PIC16F722
      case 0x1C60:        //   PIC16LF721
      case 0x1C20:        //   PIC16F721
      case 0x1C40:        //   PIC16LF720
      case 0x1C00:        //   PIC16F720
      case 0x1AE0:        //   PIC16LF707
      case 0x1AC0:        //   PIC16F707
      case 0x1240:        //   PIC16F616
      case 0x2260:        //   PIC16F610
      case 0x2240:        //   PIC12F609
      case 0x1360:        //   PIC12F617
      case 0x2180:        //   PIC12F615
      case 0x2E00:        //   PIC16LF1509
      case 0x2D40:        //   PIC16F1509
      case 0x2DE0:        //   PIC16LF1508
      case 0x2D20:        //   PIC16F1508
      case 0x2DC0:        //   PIC16LF1507
      case 0x2D00:        //   PIC16F1507
      case 0x2DA0:        //   PIC16LF1503
      case 0x2CE0:        //   PIC16F1503
      case 0x2D80:        //   PIC12LF1501
      case 0x2CC0:        //   PIC12F1501
      case 0x1500:        //   PIC12F752
                SendMsgToLog(0,"function is unavailable for this chip");        //   ,   
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
      case 0:  SendMsgToLog(14,"");             //   ,      
               SendEndTimeToLog();              //      
               LBar->Free();                    //    -
               return;                          // 
      default: SendMsgToLog(15," unknown");     //   ,      
               SendEndTimeToLog();              //      
               LBar->Free();                    //    -
               return;                          // 
    }
    LBar->Free();         //    -
    SendMsgToLog(19,"");  //    
    SendEndTimeToLog();   //      
  }
  else  SendMsgToLog(0,"Operation cancelled");  //    
}
//---------------------------------------------------------------------------
//---   READ PROGRAM & CONFIG MEMORY ----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ unsigned short Temp;

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," read program & config  memory"); //        ()
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { case 0x3020:        //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       // 1.  
                                if(!SetInitState())                     //       
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //       
                                for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                                {       if(!PIC16F630_ReadProgramMemory(i,0))           //    
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        //      8
                                        if((i+1)%8==0)
                                        {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                                        }
                                }
                                // 2.   
                                if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                                //       
                                for(unsigned int i=0; i<SelectedChip.Area3Size/2; i++)  //   
                                {       if(!PIC16F630_ReadConfigMemory(i,0))            //    
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        //      8
                                        if((i+1)%8==0)
                                        {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                        }
                                }
                                //--- -      Vpp-last, - Vdd-last,   
                                //---   ,      
                                if(!SetInitState())                   //        (   Vpp  Vdd)
                                {       SendMsgToLog(19," with fail."); //   false -     
                                        LBar->Free();                   //    -
                                        return;                         // 
                                }
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
    case 0x1200:        //   PIC16F785
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x1360:        //   PIC12F617
    case 0x2180:        //   PIC12F615
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC16F1508
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
    case 0x1500:        //   PIC12F752
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
    case 0x0FA0:        //   PIC12F635
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        // 1.  
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //       
                        for(unsigned int i=0; i<SelectedChip.Area1Size/2; i++)  //   
                        {       if(!PIC16F630_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        // 2.   
                        if(!PIC16F630_SetPCToConfigMemory())    //     Config Memory
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //       
                        for(unsigned int i=0; i<SelectedChip.Area3Size/2; i++)  //   
                        {       if(!PIC16F630_ReadConfigMemory(i,0))            //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      8
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=2*100*(i+1)/SelectedChip.Area3Size;  //    -
                                }
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -

  //        
  switch(Form1->PageControl1->TabIndex)
  {     case 0: PlaceDataToForm(1,1);      //  RichEdit1  Area1
                PlaceDataToForm(6,3);      //  RichEdit6  Area3
                break;
        case 1: PlaceDataToForm(2,1);      //  RichEdit2  Area1
                PlaceDataToForm(7,3);      //  RichEdit7  Area3
                break;
        default: break;
  }

  //  ChipID  ,       
  Temp = SelectedChip.Area3[2*6] + (SelectedChip.Area3[2*6+1] << 8);
  if( (SelectedChip.ID & 0x3FE0) != (Temp & 0x3FE0))
        Application->MessageBox("The read ChipID does not match the selected one!", "Warning", MB_OK|MB_ICONWARNING|MB_APPLMODAL);

  SendMsgToLog(19,"");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---   READ DATA -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{ //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," read the data memory");          //     
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { //     EEPROM
    case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
    case 0x1200:        //   PIC16F785
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
    case 0x0FA0:        //   PIC12F635
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        if(!SetInitState())                     //       
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!EnterHVPVMode_VPPfirst())           //        Vpp-first
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)    //   
                        {       if(!PIC16F630_ReadDataMemory(i,0))              //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      16
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        //--- -      Vpp-last, - Vdd-last,   
                        //---   ,      
                        if(!SetInitState())                   //        (   Vpp  Vdd)
                        {       SendMsgToLog(19," with fail."); //   false -     
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x3020:        //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       SendMsgToLog(0,"function is unavailable for this chip");        //   ,   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        else
                        {       SendMsgToLog(15," unknown");    //   ,      
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;
                        }
                        //break; - ,       
    //     EEPROM
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x1360:        //   PIC12F617
    case 0x2180:        //   PIC12F615
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC16F1508
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
    case 0x1500:        //   PIC12F752
                SendMsgToLog(0,"function is unavailable for this chip");        //   ,   
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -

  //        
  switch(Form1->PageControl1->TabIndex)
  {     case 0: PlaceDataToForm(3,2);      //  RichEdit3  Area2
                break;
        case 1: PlaceDataToForm(4,2);      //  RichEdit4  Area2
                break;
        default: break;
  }
  SendMsgToLog(19,"");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---      PIC16F630 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6301Click(TObject *Sender)
{ InitChip(0x10C0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F676 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6761Click(TObject *Sender)
{ InitChip(0x10E0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F629 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6291Click(TObject *Sender)
{ InitChip(0x0F80);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F675 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6751Click(TObject *Sender)
{ InitChip(0x0FC0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F635 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6351Click(TObject *Sender)
{ InitChip(0x0FA0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F683 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6831Click(TObject *Sender)
{ InitChip(0x0460);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F631 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6311Click(TObject *Sender)
{ InitChip(0x1420);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F636 / PIC16F639 -------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6361Click(TObject *Sender)
{ InitChip(0x10A0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F677 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6771Click(TObject *Sender)
{ InitChip(0x1440);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F684 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6841Click(TObject *Sender)
{ InitChip(0x1080);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F685 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6851Click(TObject *Sender)
{ InitChip(0x04A0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F687 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6871Click(TObject *Sender)
{ InitChip(0x1320);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F688 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6881Click(TObject *Sender)
{ InitChip(0x1180);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F689 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6891Click(TObject *Sender)
{ InitChip(0x1340);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F690 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6901Click(TObject *Sender)
{ InitChip(0x1400);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F752 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F7521Click(TObject *Sender)
{ InitChip(0x1500);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F1501 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F15011Click(TObject *Sender)
{ InitChip(0x2CC0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12LF1501 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12LF15011Click(TObject *Sender)
{ InitChip(0x2D80);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1503 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F15031Click(TObject *Sender)
{ InitChip(0x2CE0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1503 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF15031Click(TObject *Sender)
{ InitChip(0x2DA0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1507 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F15071Click(TObject *Sender)
{  InitChip(0x2D00);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1507 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF15071Click(TObject *Sender)
{ InitChip(0x2DC0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1508 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F15081Click(TObject *Sender)
{ InitChip(0x2D20);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1508 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF15081Click(TObject *Sender)
{ InitChip(0x2DE0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1509 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F15091Click(TObject *Sender)
{ InitChip(0x2D40);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1509 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF15091Click(TObject *Sender)
{ InitChip(0x2E00);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F615 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6151Click(TObject *Sender)
{ InitChip(0x2180);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F617 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6171Click(TObject *Sender)
{ InitChip(0x1360);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F609 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F6091Click(TObject *Sender)
{ InitChip(0x2240);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F610 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6101Click(TObject *Sender)
{ InitChip(0x2260);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F616 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F6161Click(TObject *Sender)
{ InitChip(0x1240);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F1822 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F18221Click(TObject *Sender)
{ InitChip(0x2700);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12LF1822 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12LF18221Click(TObject *Sender)
{ InitChip(0x2800);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1823 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18231Click(TObject *Sender)
{ InitChip(0x2720);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1823 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18231Click(TObject *Sender)
{ InitChip(0x2820);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1824 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18241Click(TObject *Sender)
{ InitChip(0x2740);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1824 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18241Click(TObject *Sender)
{ InitChip(0x2840);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1825 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18251Click(TObject *Sender)
{ InitChip(0x2760);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1825 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18251Click(TObject *Sender)
{ InitChip(0x2860);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1826 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18261Click(TObject *Sender)
{ InitChip(0x2780);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1826 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18261Click(TObject *Sender)
{ InitChip(0x2880);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1827 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18271Click(TObject *Sender)
{ InitChip(0x27A0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1827 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18271Click(TObject *Sender)
{ InitChip(0x28A0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1828 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18281Click(TObject *Sender)
{ InitChip(0x27C0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1828 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18281Click(TObject *Sender)
{ InitChip(0x28C0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1829 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18291Click(TObject *Sender)
{ InitChip(0x27E0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1829 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18291Click(TObject *Sender)
{ InitChip(0x28E0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12F1840 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12F18401Click(TObject *Sender)
{ InitChip(0x1B80);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC12LF1840 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC12LF18401Click(TObject *Sender)
{ InitChip(0x1BC0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F1847 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F18471Click(TObject *Sender)
{ InitChip(0x1480);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF1847 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF18471Click(TObject *Sender)
{ InitChip(0x14A0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F753 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7531Click(TObject *Sender)
{ //        5  ID,     ID
  InitChip(0x3030);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F753 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7851Click(TObject *Sender)
{ InitChip(0x1200);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F627A ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F627A1Click(TObject *Sender)
{ InitChip(0x1040);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F628A ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F628A1Click(TObject *Sender)
{ InitChip(0x1060);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F648A ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F648A1Click(TObject *Sender)
{ InitChip(0x1100);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F707 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7071Click(TObject *Sender)
{ InitChip(0x1AC0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF707 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7071Click(TObject *Sender)
{ InitChip(0x1AE0);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F720 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7201Click(TObject *Sender)
{ InitChip(0x1C00);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF720 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7201Click(TObject *Sender)
{ InitChip(0x1C40);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F721 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7211Click(TObject *Sender)
{ InitChip(0x1C20);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF721 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7211Click(TObject *Sender)
{ InitChip(0x1C60);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F722 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7221Click(TObject *Sender)
{ InitChip(0x1880);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF722 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7221Click(TObject *Sender)
{ InitChip(0x1980);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F722A ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F722A1Click(TObject *Sender)
{ InitChip(0x1B20);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF722A -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF722A1Click(TObject *Sender)
{ InitChip(0x1B60);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F723 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7231Click(TObject *Sender)
{ InitChip(0x1860);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF723 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7231Click(TObject *Sender)
{ InitChip(0x1960);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F723A ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F723A1Click(TObject *Sender)
{ InitChip(0x1B00);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF723A -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF723A1Click(TObject *Sender)
{ InitChip(0x1B40);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F726 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7261Click(TObject *Sender)
{ InitChip(0x1820);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF726 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7261Click(TObject *Sender)
{ InitChip(0x1920);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F724 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7241Click(TObject *Sender)
{ InitChip(0x1840);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF724 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7241Click(TObject *Sender)
{ InitChip(0x1940);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F727 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F7271Click(TObject *Sender)
{ InitChip(0x1800);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16LF727 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16LF7271Click(TObject *Sender)
{ InitChip(0x1900);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F882 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F8821Click(TObject *Sender)
{ InitChip(0x2000);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F883 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F8831Click(TObject *Sender)
{ InitChip(0x2020);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F884 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F8841Click(TObject *Sender)
{ InitChip(0x2040);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F886 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F8861Click(TObject *Sender)
{ InitChip(0x2060);                    //   ,   
}
//---------------------------------------------------------------------------
//---      PIC16F887 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::PIC16F8871Click(TObject *Sender)
{ InitChip(0x2080);                    //   ,   
}
//---------------------------------------------------------------------------

